<?php
/**
*
* @package TS Gallery
* @version $Id: edit_post.php v0.1.1 02.12.2007 00:02:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
include($phpbb_root_path . 'includes/gallery.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// language file
$user->setup('mods/gallery');
$gallery = new Gallery();


// Authorisation process

//TO DO: allow admin only to be set via ACP

$admin_only == true;

// don't create a deadend for bots
if ($user->data['is_bot'])
			{
				$meta_info = append_sid("{$phpbb_root_path}index.$phpEx");
				meta_refresh(0, $meta_info);
			}


$mode	= request_var('mode', '');
$post_id = request_var('p', 0);
$pic_id = request_var('i', 0);

			$sql = 'SELECT *
				FROM ' . GALLERY_COMMENT_TABLE . "
				WHERE comment_id = $post_id";
                  $result = $db->sql_query($sql);
			$post_data = $db->sql_fetchrow($result);


		if (!$sql)
			{
				$user->setup('posting');
				trigger_error('NO_POST_MODE');
			}

		if ($post_data['comment_user_id'] == $user->data['user_id'] || $auth->acl_get('a_'))
			{
				$is_authed = true;
			}

		if (!$is_authed)
			{
				trigger_error($user->lang['GALLERY_NOT_AUTHORISED']);
			}

// If we want to secure the edit function for Admin only (which with this release we do) we use this catchall

if (!$auth->acl_get('a_') && $admin_only == true)
	{	
		$gallery->redirect(append_sid("menu.$phpEx"), $user->lang['GALLERY_ADMIN_ONLY'], 7);	
	}

switch ($mode)
{
	case 'edit':

		decode_message($post_data['comment_text']);

		$template->assign_vars(array(
			'EDIT_POST_ACTION'	=> append_sid("edit_post.{$phpEx}"),
			'COMMENT'			=> $post_data['comment_text'],
			'P'				=> $post_id,
			'I'				=> $pic_id,
			'MODE'			=> 'post'
			)
		   );

	break;
	
	case 'post':
		
		$submit = isset($_POST['submit']) ? true : false;
		$is_comment = isset($_POST['comment']) ? true : false;
		$cancel = isset($_POST['cancel']) ? true : false;
		$comment = request_var('comment', '', true);

		if  (strlen($comment) < 1)
			{
				$is_comment = false;
			}

		if (!$submit || $cancel)
   			{
				$redirect_url = append_sid("{$phpbb_root_path}gallery/viewpic.{$phpEx}?pic_id={$pic_id}");
				$redirect_message	= $user->lang['GALLERY_COMMENT_NOT_EDITED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url);
				$gallery->redirect($redirect_url, $redirect_message, 7);
			}
		elseif (!$is_comment)
				{
					$user->setup('posting');
					trigger_error ('TOO_FEW_CHARS');	
				}
		else
			{
				$uid = $bitfield = $flags = '';
				$allow_bbcode = $allow_urls = $allow_smilies = true;						
				generate_text_for_storage($comment, $uid, $bitfield, $flags, $allow_bbcode, $allow_urls, $allow_smilies);
						$data = array (
							'comment_text'			=> $comment,
							'comment_bbcode_bitfield'	=> $bitfield,
							'comment_bbcode_uid'		=> $uid,
							'comment_bbcode_flags'		=> $flags
						);

				$sql = 'UPDATE ' . GALLERY_COMMENT_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data) . ' WHERE comment_id = ' . $post_id ;
				$db->sql_query($sql);

				$redirect_url = append_sid("{$phpbb_root_path}gallery/viewpic.{$phpEx}?pic_id={$pic_id}");
				$redirect_message	= $user->lang['GALLERY_COMMENT_EDITED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
				$gallery->redirect(append_sid("viewpic.{$phpEx}?pic_id={$pic_id}"), $redirect_message, 7);
			}
				
	break;

	case 'delete':

		if (confirm_box(true))
			{
				$sql = 'DELETE FROM ' . GALLERY_COMMENT_TABLE . "
					WHERE comment_id = $post_id";
				$db->sql_query($sql);

				$redirect_url		= append_sid("{$phpbb_root_path}/gallery/viewpic.{$phpEx}?pic_id={$pic_id}");
				$redirect_message	= $user->lang['GALLERY_COMMENT_DELETED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
				$gallery->redirect($redirect_url, $redirect_message, 7);
			}	
		else
			{		
				$s_hidden_fields = build_hidden_fields(array(
					'p'		=> $post_id,
					'i'		=> $pic_id,
					'mode'	=> 'delete', 
					)
				);
			
				confirm_box(false, $user->lang['GALLERY_DELETE_MESSAGE'], $s_hidden_fields, $html_body = 'confirm_body.html', $u_action = 'gallery/edit_post.php');
			}
		
				$redirect_url = append_sid("{$phpbb_root_path}gallery/viewpic.{$phpEx}?pic_id={$pic_id}");
				$redirect_message	= $user->lang['GALLERY_COMMENT_NOT_DELETED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
				$gallery->redirect($redirect_url, $redirect_message, 7);

	break;

}

$db->sql_freeresult($result);

	generate_smilies('inline', false);

// Menu
$gallery->generate_menu(GALLERY_PAGE_VIEWPIC);

// Output the page
page_header($user->lang['GALLERY_TITLE']);

$template->set_filenames(array(
    'body' => 'gallery/gallery_edit_post.html')
);

page_footer();
?>