<?php
/**
*
* @package TS Gallery
* @version $Id: install.php v0.1.1 04.12.2007 08:56:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

$sql = array();


if (!$user->data['is_registered'])
{
    if ($user->data['is_bot'])
    {
        redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
    }
    login_box();
}
else if ($user->data['user_type'] != USER_FOUNDER)
{
	trigger_error('What\'s up ?');
	exit;
}

if (isset($config['gallery_version']) && version_compare($config['gallery_version'], '0.1.1', '='))
{
	trigger_error('The instalation script has detected that you already have the latest version of Photo Gallery!');
	exit;
}

switch ($db->sql_layer)
{
	case 'mysql':
		$db_type = 'mysql_40';
	break;

	case 'mysql4':
		if (version_compare($db->mysql_version, '4.1.3', '>='))
		{
			$db_type = 'mysql_41';
		}
		else
		{
			$db_type = 'mysql_40';
		}
	break;

	case 'mysqli':
		$db_type = 'mysql_41';
	break;

	default:
		$db_type = $db->sql_layer;
	break;
}

switch ($db_type)
{
	case 'mysql_40':
		include("mysql40.{$phpEx}");
	break;
	case 'mysql_41':
		include("mysql41.{$phpEx}");
	break;
	default:
		trigger_error('Your database type isn\'t supported... yet.');
	break;
}

foreach($sql as $sql_query)
{
	$db->sql_query($sql_query);
}

// Add acp modules
$modules = new acp_modules();

$acp_cat_gallery = array(
	'module_basename'	=> '',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> 0,
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_CAT_GALLERY',
	'module_mode'	=> '',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_cat_gallery);

$acp_gallery_management = array(
	'module_basename'	=> '',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_cat_gallery['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_MANAGEMENT',
	'module_mode'	=> '',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_management);

$acp_gallery_manage_albums = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_management['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_MANAGE_ALBUMS',
	'module_mode'	=> 'manage_albums',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_manage_albums);

$acp_gallery_create_album = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_management['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_CREATE_ALBUM',
	'module_mode'	=> 'create_album',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_create_album);

$acp_gallery_manage_cache = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_management['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_MANAGE_CACHE',
	'module_mode'	=> 'manage_cache',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_manage_cache);

$acp_gallery_settings = array(
	'module_basename'	=> '',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_cat_gallery['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_SETTINGS',
	'module_mode'	=> '',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_settings);

$acp_gallery_general_settings = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_settings['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_GENERAL_SETTINGS',
	'module_mode'	=> 'general_settings',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_general_settings);

$acp_gallery_user_settings = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_settings['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_USER_SETTINGS',
	'module_mode'	=> 'user_settings',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_user_settings);

$acp_gallery_guest_settings = array(
	'module_basename'	=> 'gallery',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> $acp_gallery_settings['module_id'],
	'module_class'	=> 'acp',
	'module_langname'	=> 'ACP_GALLERY_GUEST_SETTINGS',
	'module_mode'	=> 'guest_settings',
	'module_auth'	=> ''
);
$modules->update_module_data($acp_gallery_guest_settings);

// Add ucp modules

$ucp_gallery_prefs = array(
	'module_basename'	=> 'gallery_prefs',
	'module_enabled'	=> 1,
	'module_display'	=> 1,
	'parent_id'		=> 0,
	'module_class'	=> 'ucp',
	'module_langname'	=> 'UCP_GALLERY_PREFS',
	'module_mode'	=> 'personal',
	'module_auth'	=> ''
);
$modules->update_module_data($ucp_gallery_prefs);

add_log('admin', 'TS Photo Gallery 0.1.1 installed');
$cache->purge();
add_log('admin', 'LOG_PURGE_CACHE');
$message = "Photo Gallery successfully installed.<br />
			For security reasons please delete <b>install</b> folder.";
trigger_error($message);

?>