<?php
/**
*
* @package TS Gallery
* @version $Id: mysql40.php v0.1.1 02.12.2007 00:02:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

$sql[] = "CREATE TABLE {$table_prefix}gallery_pics (
			pic_id  mediumint(8) UNSIGNED NOT NULL auto_increment,
			pic_album_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			pic_physical_filename varbinary(255) NOT NULL,
			pic_real_filename varbinary(255) NOT NULL,
			pic_filesize int(20) UNSIGNED DEFAULT '0' NOT NULL,
			pic_mimetype varbinary(255) DEFAULT '' NOT NULL,
			pic_title varbinary(255) DEFAULT '' NOT NULL,
			pic_desc mediumblob,
			pic_user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			pic_username varbinary(255) DEFAULT '' NOT NULL,
			pic_user_ip varbinary(40) DEFAULT '' NOT NULL,
			pic_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
			pic_views mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			pic_lock tinyint(1) NOT NULL DEFAULT '0',
			PRIMARY KEY (pic_id),
			KEY pic_cat_id (pic_album_id),
			KEY pic_user_id (pic_user_id),
			KEY pic_time (pic_time)
		)";


$sql[] = "CREATE TABLE {$table_prefix}gallery_rate (
			rate_pic_id int(11) UNSIGNED NOT NULL,
			rate_user_id mediumint(8) NOT NULL,
			rate_user_ip varbinary(40) DEFAULT '' NOT NULL,
			rate_point tinyint(3) UNSIGNED NOT NULL,
			KEY rate_pic_id (rate_pic_id),
			KEY rate_user_id (rate_user_id),
			KEY rate_user_ip (rate_user_ip),
			KEY rate_point (rate_point)
		)";


$sql[] = "CREATE TABLE {$table_prefix}gallery_comment (
			comment_id mediumint(8) UNSIGNED NOT NULL auto_increment,
			comment_pic_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			comment_album_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			comment_user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			comment_user_ip varbinary(40) DEFAULT '' NOT NULL,
			comment_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
			comment_username varbinary(255) DEFAULT '' NOT NULL,
			comment_text blob NOT NULL,
			comment_bbcode_bitfield varbinary(255) DEFAULT '' NOT NULL,
			comment_bbcode_uid varbinary(5) DEFAULT '' NOT NULL,
			comment_bbcode_flags tinyint(1) NOT NULL DEFAULT '0', 
			comment_approved tinyint(1) NOT NULL DEFAULT '1',
			comment_edit_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
			comment_edit_reason varbinary(255) DEFAULT '' NOT NULL,
			comment_edit_user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			comment_edit_username varbinary(32),
			comment_edit_count smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
			PRIMARY KEY(comment_id),
			KEY comment_pic_id (comment_pic_id),
			KEY comment_user_id (comment_user_id),
			KEY comment_user_ip (comment_user_ip)
		)";


$sql[] = "CREATE TABLE {$table_prefix}gallery_albums (
			album_id mediumint(8) UNSIGNED NOT NULL auto_increment,
			album_parent_id mediumint(8) UNSIGNED DEFAULT '0',
			album_left_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			album_right_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
			album_name varbinary(255) DEFAULT '' NOT NULL,
			album_desc mediumblob,
			album_user_id mediumint(8) UNSIGNED DEFAULT '0',
			album_show_gallery tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
			album_allow_comments tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
			album_comment_approval tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
			PRIMARY KEY (album_id),
			KEY album_left_right_id (album_left_id, album_right_id)
		)";


$sql[] = "CREATE TABLE {$table_prefix}gallery_config (
			config_name varbinary(255) NOT NULL,
			config_value varbinary(255) NOT NULL,
			PRIMARY KEY (config_name)
		)";


$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('pics_per_page', '20')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('comments_per_page', '15')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('comments_to_access', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('comments_to_post', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('comments_need_approval', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('guests_can_access', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('guests_can_comment', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('guests_need_approval', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('guests_can_upload', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_upload', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_delete_images', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_comment', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_edit_comments', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_delete_comments', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_move_pics', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_create_subalbums', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_delete_subalbums', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('max_subalbums', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('users_can_set_approval', '0')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('max_filesize', '524288')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('max_width', '800')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('max_height', '600')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('bigger_allowed', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('jpg_allowed', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('gif_allowed', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('png_allowed', '1')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('thumbnail_quality', '70')";
$sql[] = "INSERT INTO {$table_prefix}gallery_config (config_name, config_value) VALUES('thumbnail_cache', '1')";
$sql[] = "INSERT INTO {$table_prefix}config (config_name, config_value) VALUES('gallery_version', '0.1.1')";
?>