<?php
/**
*
* @package TS Gallery
* @version $Id: menu.php v0.1.1 02.12.2007 00:02:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/gallery.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// language file
$user->setup('mods/gallery');
$gallery = new Gallery();
$thispage = GALLERY_PAGE_BROWSE;

$gallery->load_config();
$min_posts		= (int) $gallery->get_config('comments_to_access');
if ($min_posts > 0)
	{
		$guest_access = false;
	}
else
	{
		$guest_access	= ($gallery->get_config('guests_can_access')) ? true : false;
	}
$pics_per_page 	= (int) $gallery->get_config('pics_per_page');
$has_posted 	= (int) $user->data['user_posts'];

if (!$guest_access  && !$user->data['is_registered'])
{
	login_box();
}

if ($has_posted >= $min_posts)
	{

$template->assign_vars(array(
	'L_ALBUM_LINK'		=> '',
	'L_GALLERY_TITLE' => $user->lang['GALLERY_TITLE']
	)
);


$album = isset($_GET['album_id']) ? true : false;
$album_id = (int) request_var('album_id', 0);
if ( $album && $album_id > 0 )
{

	$sql = 'SELECT a.*, COUNT(DISTINCT p.pic_id) AS pics, COUNT(DISTINCT c.comment_id) AS comments 
			FROM ' . GALLERY_ALBUMS_TABLE . ' AS a
				LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON a.album_id = c.comment_album_id  
				LEFT JOIN ' . GALLERY_PICS_TABLE . " AS p ON a.album_id = p.pic_album_id 
			WHERE album_user_id = 0 
				AND album_parent_id = $album_id
			GROUP BY album_id";
	$result = $db->sql_query($sql);
	if ($row = $db->sql_fetchrow($result))
	{
		$template->assign_vars(array(
			'L_ALBUM_NAME'		=> 'Album name',
			'L_ALBUM_PICS'		=> 'Pictures',
			'L_ALBUM_COMMENTS'	=> 'Comments'
			)
		);
		do
		{
			$template->assign_block_vars('albums', array(
				'U_ALBUM'		=> append_sid("menu.{$phpEx}", 'album_id=' . $row['album_id']),
				'ALBUM_NAME'	=> $row['album_name'],
				'ALBUM_DESC'	=> $row['album_desc'],
				'ALBUM_PICS'	=> $row['pics'],
				'ALBUM_COMMENTS'=> $row['comments']
				)
			);
		}
		while ($row = $db->sql_fetchrow($result));
	}
	$db->sql_freeresult($result);

	// display photos
	$sql = "SELECT album_name, album_user_id  
			FROM " . GALLERY_ALBUMS_TABLE . " 
			WHERE album_id = $album_id";
	$result = $db->sql_query($sql);
	if ($row = $db->sql_fetchrow($result))
	{
		$template->assign_vars(array(
			'S_SHOW_PICS'		=> true,
			'PICS_ALBUM_NAME'	=> $row['album_name']
			)
		);
		if ( (int)$row['album_user_id'] == (int)$user->data['user_id'] )
		{
			$thispage = GALLERY_PAGE_MYALBUM;
		}
	}
	
	$start = request_var('start', 0);
	// Pagination
	$sql = 'SELECT COUNT(pic_id) AS num_pics 
			FROM ' . GALLERY_PICS_TABLE . "
			WHERE pic_album_id = $album_id";
	$result = $db->sql_query($sql);
	$total_pics = (int) $db->sql_fetchfield('num_pics');
	if ($start < 0 || $start > $total_pics)
	{
		$start = ($start < 0) ? 0 : floor(($total_pics - 1) / $pics_per_page) * $pics_per_page;
	}
    $pagination = generate_pagination(append_sid("menu.$phpEx", "album_id={$album_id}"), $total_pics, $pics_per_page, $start);
	$template->assign_vars(array(
		'PAGINATION' 	=> $pagination,
		'PAGE_NUMBER' 	=> on_page($total_pics, $pics_per_page, $start),
		'TOTAL_PICS'	=> ($total_pics == 1) ? $user->lang['GALLERY_PG_PICTURE'] : sprintf($user->lang['GALLERY_PG_PICTURES'], $total_pics),
		)
	);
	//EoP
	
	$sql = 'SELECT p.*, r.rate_pic_id, AVG(r.rate_point) AS rating, COUNT(DISTINCT c.comment_id) AS comments 		
			FROM ' . GALLERY_PICS_TABLE . ' AS p
				LEFT JOIN ' . GALLERY_RATE_TABLE . ' AS r ON p.pic_id = r.rate_pic_id 
				LEFT JOIN ' . GALLERY_COMMENT_TABLE . " AS c ON p.pic_id = c.comment_pic_id 
			WHERE pic_album_id = $album_id 
			GROUP BY p.pic_id 
			ORDER BY p.pic_time DESC"; 
	$result = $db->sql_query_limit($sql, $pics_per_page, $start);
	if ($row = $db->sql_fetchrow($result))
	{
		$step = 0;
		$template->assign_block_vars('picsrow', array());
		do
		{
			$step++;
			$template->assign_block_vars('picsrow.picscolumn', array(
				'S_IS_PHOTO'			=> true,
				'U_PIC_LINK'			=> append_sid("viewpic.$phpEx?pic_id=" . $row['pic_id']),
				'U_PIC_SRC'				=> "pic.{$phpEx}?mode=small&amp;pic_id=" . $row['pic_id'],
				'PIC_NAME'				=> $row['pic_real_filename'],
				'PIC_TITLE'				=> $row['pic_title'],
				'L_PIC_UPLOADED_BY'		=> $user->lang['GALLERY_UPLOADED_BY'],
				'PIC_UPLOADER_PROFILE'	=> append_sid("{$phpbb_root_path}memberlist.{$phpEx}?mode=viewprofile&amp;u=" . $row['pic_user_id']),
				'PIC_UPLOADER'			=> $row['pic_username'],
				'L_PIC_ON'				=> $user->lang['GALLERY_UPLOADED_ON_DATE'],
				'PIC_TIME'				=> strftime("%d.%m.%Y %H:%M:%S", $row['pic_time']),
				'L_PIC_FILESIZE'		=> $user->lang['GALLERY_SIZE'],
				'PIC_FILESIZE'			=> floor( (float) $row['pic_filesize'] / 1024 ),
				'L_PIC_COMMENTS'		=> $user->lang['GALLERY_COMMENTS'],
				'PIC_COMMENTS'			=> $row['comments'],
				'L_PIC_VIEWS'			=> $user->lang['GALLERY_VIEWS'],
				'PIC_VIEWS'				=> $row['pic_views'],
				'L_PIC_RATING'			=> $user->lang['GALLERY_RATING'],
				'PIC_RATING'			=> ( $row['rating'] ? round($row['rating'], 2) : 'Not rated yet.')
				)
			);
			if (!($step % 5))
			{
				$template->assign_block_vars('picsrow', array());
			}
		}
		while ($row = $db->sql_fetchrow($result));
	
		$leftover = $step % 5;
		for ($i = $leftover; $i < 5; $i++)
		{
			$template->assign_block_vars('picsrow.picscolumn', array(
				'S_IS_PHOTO'		=> false
				)
			);
		}
	}
}
else
{
	$gallery_type = request_var('gallery', '');
	$this_user = $user->data['user_id'];
	switch ($gallery_type)
	{
		case 'members':

			$sql = 'SELECT a.*, COUNT(DISTINCT p.pic_id) AS pics, COUNT(DISTINCT c.comment_id) AS comments  
					FROM ' . GALLERY_ALBUMS_TABLE . ' AS a
						LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON a.album_id = c.comment_album_id  
						LEFT JOIN ' . GALLERY_PICS_TABLE . ' AS p ON a.album_id = p.pic_album_id 
					WHERE album_user_id <> 0 
						AND album_parent_id = 0
					GROUP BY album_id';
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				$template->assign_vars(array(

					'L_ALBUM_NAME'		=> $user->lang['GALLERY_ALBUM_NAME'],
					'L_ALBUM_PICS'		=> $user->lang['GALLERY_PICTURES'],
					'L_ALBUM_COMMENTS'	=> $user->lang['GALLERY_COMMENTS']
					)
				);
				do
				{
					$album_user = $row['album_user_id'];

					$lock = ($row['album_show_gallery']) ? true : false;
					if ($this_user !== $album_user && $lock)
						{
							$sql2 = 'SELECT friend
								FROM ' . ZEBRA_TABLE . "
								WHERE zebra_id = $this_user
								AND user_id = $album_user";
							$info = $db->sql_query($sql2);
							$friend_info = $db->sql_fetchrow($info);
							$friend = ($friend_info['friend']) ? true : false;
							$db->sql_freeresult($info);
							
						if (!$friend && !$auth->acl_gets('a_', 'm_'))
							{
								$template->assign_block_vars('albums', array(
									'T_LOCKED'		=> true,
									'ALBUM_NAME'	=> $row['album_name'],
									'ALBUM_DESC'	=> sprintf($user->lang['GALLERY_USER_PERSONAL_GALLERY_LOCKED'], $row['album_name']),
									'ALBUM_PICS'	=> $row['pics'],
									'ALBUM_COMMENTS'=> $row['comments']
															)
														);
							}
						else
							{
								$template->assign_block_vars('albums', array(
									'U_ALBUM'		=> append_sid("menu.{$phpEx}", 'gallery=members&amp;album_id=' . $row['album_id']),
									'ALBUM_NAME'	=> $row['album_name'],
									'ALBUM_DESC'	=> sprintf($user->lang['GALLERY_USER_PERSONAL_GALLERY_LOCKED'], $row['album_name']),
									'ALBUM_PICS'	=> $row['pics'],
									'ALBUM_COMMENTS'=> $row['comments']
															)
														);
							}
						}
					else
						{
								$template->assign_block_vars('albums', array(
									'U_ALBUM'		=> append_sid("menu.{$phpEx}", 'gallery=members&amp;album_id=' . $row['album_id']),
									'ALBUM_NAME'	=> $row['album_name'],
									'ALBUM_DESC'	=> sprintf($user->lang['GALLERY_USER_PERSONAL_GALLERY'], $row['album_name']),
									'ALBUM_PICS'	=> $row['pics'],
									'ALBUM_COMMENTS'=> $row['comments']
															)
														);
						}
				}			
				while ($row = $db->sql_fetchrow($result));
			}
			$db->sql_freeresult($result);
		break;
			
		case 'public':
		default:
			$sql = 'SELECT COUNT(*) AS nr  
					FROM ' . GALLERY_ALBUMS_TABLE . ' 
					WHERE album_user_id <> 0';
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				$template->assign_vars(array(
					'S_MEMBERS_GALLERY'		=> true,
					'L_MEMBERS_GALLERY'		=> $user->lang['GALLERY_MEMBERS_GALLERY'],
					'L_GALLERY_ALBUMS'		=> $user->lang['GALLERY_ALBUMS'],
					'U_MEMBERS_GALLERY'		=> append_sid("menu.{$phpEx}", "gallery=members"),
					'MEMBERS_GALLERY'		=> $user->lang['GALLERY_MEMBERS_GALLERY'],
					'MEMBERS_GALLERY_DESC'	=> $user->lang['GALLERY_MEMBERS_GALLERY_DESCR'],
					'GALLERY_ALBUMS'		=> $row['nr']
					)
				);
			}
			$db->sql_freeresult($result);

			$sql = 'SELECT a.*, COUNT(DISTINCT p.pic_id) AS pics, COUNT(DISTINCT c.comment_id) AS comments  
					FROM ' . GALLERY_ALBUMS_TABLE . ' AS a
						LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON a.album_id = c.comment_album_id  
						LEFT JOIN ' . GALLERY_PICS_TABLE . ' AS p ON a.album_id = p.pic_album_id 
					WHERE album_user_id = 0 
						AND album_parent_id = 0
					GROUP BY album_id
					ORDER BY album_left_id ASC';

			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				$template->assign_vars(array(
					'L_ALBUM_NAME'		=> $user->lang['GALLERY_ALBUM_NAME'],
					'L_ALBUM_PICS'		=> $user->lang['GALLERY_PICTURES'],
					'L_ALBUM_COMMENTS'	=> $user->lang['GALLERY_COMMENTS']
					)
				);
				
				do
				{
					$sub_albums_list = '';
					$sub_is_first = true;
					$sql = 'SELECT a.*, COUNT(DISTINCT p.pic_id) AS pics  
							FROM ' . GALLERY_ALBUMS_TABLE . ' AS a
								LEFT JOIN ' . GALLERY_PICS_TABLE . ' AS p ON a.album_id = p.pic_album_id 
							WHERE album_user_id = 0 
								AND album_parent_id = ' . $row['album_id'] . '
							GROUP BY album_id';
					$sub_result = $db->sql_query($sql);
					if ($sub_row = $db->sql_fetchrow($sub_result))
					{
						$sub_albums_list = '';
						do
						{
							$sub_albums_list .= ($sub_is_first ? '' : ', ') . '<a href="' . append_sid('menu.' . $phpEx . '?gallery=public&amp;album_id=' . $sub_row['album_id']) . '" class="subforum read">' . $sub_row['album_name'] . ' [' . $sub_row['pics'] . ']</a> ';
							$sub_is_first = false;
						}
						while ($sub_row = $db->sql_fetchrow($sub_result));
					}
					
					$template->assign_block_vars('albums', array(
						'U_ALBUM'		=> append_sid("menu.{$phpEx}", "gallery=public&amp;album_id=" . $row['album_id']),
						'ALBUM_NAME'	=> $row['album_name'],
						'ALBUM_DESC'	=> $row['album_desc'],
						'SUBALBUMS'		=> $user->lang['GALLERY_SUBALBUMS'],
						'SUBALBUMS_LIST'=> $sub_albums_list,
						'ALBUM_PICS'	=> $row['pics'],
						'ALBUM_COMMENTS'=> $row['comments']
						)
					);
				}
				while ($row = $db->sql_fetchrow($result));
			}
			$db->sql_freeresult($result);
		break;
	}
}
}
else //if user post count is too low
	{
		$remaining = $min_posts - $has_posted;
		if ($remaining == 1)
			{
				$s = '';
			}
		else
			{
				$s = 's';
			}
		$redirect_url = append_sid("{$phpbb_root_path}index.{$phpEx}");
		$redirect_message = sprintf($user->lang['REQUIRED_POSTS'], $remaining) . $s . '<br />&nbsp;<br />' . sprintf($user->lang['GALLERY_REDIRECT_TO_FORUM_MSG'], $redirect_url);
		$gallery->redirect($redirect_url, $redirect_message, 10);
	}
// Menu
$gallery->generate_menu($thispage);

// Output the page
page_header($user->lang['GALLERY_TITLE']);

$template->set_filenames(array(
    'body' => 'gallery/gallery_menu.html')
);

page_footer();
?>