<?php
/**
*
* @package TS Gallery
* @version $Id: pic.php v0.1.1 02.12.2007 00:02:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require($phpbb_root_path . 'config.' . $phpEx);
require($phpbb_root_path . 'includes/db/' . $dbms . '.' . $phpEx);
require($phpbb_root_path . 'includes/constants.' . $phpEx);
require($phpbb_root_path . 'includes/gallery.' . $phpEx);

$db = new $sql_db();
$gallery = new Gallery();

// Connect to DB
if (!@$db->sql_connect($dbhost, $dbuser, $dbpasswd, $dbname, $dbport, false, false))
{
	exit;
}
unset($dbpasswd);

$is_mode	= isset($_GET['mode']) ? true : false;
$is_pic_id	= isset($_GET['pic_id']) ? true : false;
$mode 		= $_GET['mode'];
$pic_id 	= intval($_GET['pic_id']);

if ( !($is_mode && $is_pic_id) )
{
	exit;
}

$sql = 'SELECT pic_physical_filename, pic_real_filename, pic_mimetype
 			FROM ' . GALLERY_PICS_TABLE . " 
			WHERE pic_id = $pic_id";
$result = $db->sql_query($sql);
if (!$row = $db->sql_fetchrow($result))
{
	exit;
}

$small_pic		= 'upload/cache/small_' . $row['pic_physical_filename'];
$med_pic		= 'upload/cache/med_' . $row['pic_physical_filename'];
$large_pic		= 'upload/pics/' . $row['pic_physical_filename'];
$pic_mimetype	= $row['pic_mimetype'];
$pic_realname	= $row['pic_real_filename'];
$gallery->load_config();

if ( (int) $gallery->get_config('thumbnail_cache') == 1 )
{
	if (!file_exists($small_pic))
	{
		$gallery->create_thumbnail($large_pic, $small_pic, $pic_mimetype, 'small');
	}

	if (!file_exists($med_pic))
	{
		$gallery->create_thumbnail($large_pic, $med_pic, $pic_mimetype, 'med');
	}
}

switch ($mode)
{
	case 'small':
		if (@file_exists($small_pic) && @is_readable($small_pic))
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: inline; filename="' . $pic_realname . '"');
			header('Content-Length: ' . filesize($small_pic));
			readfile($small_pic);
			die;
		}
		else
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: inline; filename="' . $pic_realname . '"');
			$gallery->create_thumbnail($large_pic, '', $pic_mimetype, 'small');
			die;
		}
	break;
	
	case 'med':
		if (@file_exists($med_pic) && @is_readable($med_pic))
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: inline; filename="' . $pic_realname . '"');
			header('Content-Length: ' . filesize($med_pic));
			readfile($med_pic);
			die;
		}
		else
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: inline; filename="' . $pic_realname . '"');
			$gallery->create_thumbnail($large_pic, '', $pic_mimetype, 'med');
			die;
		}
	break;
	
	case 'download':
		if (@file_exists($large_pic) && @is_readable($large_pic))
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: attachment; filename="' . $pic_realname . '"');
			header('Content-Length: ' . filesize($large_pic));
			readfile($large_pic);
		}
		die;
	break;
	
	default;
		if (@file_exists($large_pic) && @is_readable($large_pic))
		{
			header('Pragma: public');
			header("Content-Type: $pic_mimetype");
			header('Content-Disposition: inline; filename="' . $pic_realname . '"');
			header('Content-Length: ' . filesize($large_pic));
			readfile($large_pic);
		}
		die;
	break;
}

$db->sql_close();
exit;

?>