<?php
/**
*
* @package TS Gallery
* @version $Id: recent.php v0.1.1 02.12.2007 00:28:57 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/gallery.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// language file
$user->setup('mods/gallery');
$gallery = new Gallery();
$gallery->load_config();
$min_posts		= (int) $gallery->get_config('comments_to_access');
if ($min_posts > 0)
	{
		$guest_access = false;
	}
else
	{
		$guest_access	= ($gallery->get_config('guests_can_access')) ? true : false;
	}
$pics_per_page 	= (int) $gallery->get_config('pics_per_page');
$has_posted 	= (int) $user->data['user_posts'];

if (!$guest_access  && !$user->data['is_registered'])
{
	login_box();
}

if ($has_posted >= $min_posts)
	{
$template->assign_vars(array(
	'L_ALBUM_LINK'	=> $user->lang['GALLERY_ALBUM_LINK'],
	'L_GALLERY_TITLE'	=> $user->lang['GALLERY_TITLE'],
	'PICS_ALBUM_NAME'	=> $user->lang['GALLERY_MOST_RECENT_PICS']
	)
);

if ($auth->acl_get('a_'))
	{
		$skel_key = true;
	}
else
	{
		$skel_key = false;
	}

$this_user = $user->data['user_id'];
$start = request_var('start', 0);
$total_pics = $gallery->get_num_pics('pic_id' , 'pic_id', $this_user, $skel_key);
$pics_per_page = (int) $gallery->get_config('pics_per_page');


if ($skel_key)
	{
		$sql = 'SELECT p.*, a.*, r.rate_pic_id, AVG(r.rate_point) AS rating, COUNT(DISTINCT c.comment_id) AS comments
			FROM ' . GALLERY_PICS_TABLE . ' AS p
			LEFT JOIN ' . GALLERY_ALBUMS_TABLE . ' AS a ON p.pic_album_id = a.album_id
			LEFT JOIN ' . GALLERY_RATE_TABLE . ' AS r ON p.pic_id = r.rate_pic_id 
			LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON p.pic_id = c.comment_pic_id 
			GROUP BY p.pic_id 
			ORDER BY pic_time DESC';
	}
else
	{
		$sql = 'SELECT p.*, a.*, r.rate_pic_id, AVG(r.rate_point) AS rating, COUNT(DISTINCT c.comment_id) AS comments, z.*
			FROM ' . GALLERY_PICS_TABLE . ' AS p
			LEFT JOIN ' . GALLERY_ALBUMS_TABLE . ' AS a ON p.pic_album_id = a.album_id
			LEFT JOIN ' . GALLERY_RATE_TABLE . ' AS r ON p.pic_id = r.rate_pic_id 
			LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON p.pic_id = c.comment_pic_id 
			LEFT JOIN ' . ZEBRA_TABLE . ' AS z ON p.pic_user_id = z.user_id && z.zebra_id = ' . $this_user . '
			WHERE a.album_show_gallery = 0 OR z.friend = 1 OR p.pic_user_id = ' . $this_user . '
			GROUP BY p.pic_id 
			ORDER BY pic_time DESC';
	}

$result = $db->sql_query_limit($sql, $pics_per_page , $start);
if ($row = $db->sql_fetchrow($result))
	{
		$step = 0;
		$template->assign_block_vars('picsrow', array());
		do
			{
				$step++;
				$template->assign_block_vars('picsrow.picscolumn', array(
					'L_PIC_COMMENTS'			=> $user->lang['GALLERY_COMMENTS'],
					'L_PIC_FILESIZE'			=> $user->lang['GALLERY_SIZE'],
					'L_PIC_ON'				=> $user->lang['GALLERY_UPLOADED_ON_DATE'],
					'L_PIC_RATING'			=> $user->lang['GALLERY_RATING'],
					'L_PIC_UPLOADED_BY'		=> $user->lang['GALLERY_UPLOADED_BY'],
					'L_PIC_VIEWS'			=> $user->lang['GALLERY_VIEWS'],

					'PIC_COMMENTS'			=> $row['comments'],
					'PIC_FILESIZE'			=> floor( (float) $row['pic_filesize'] / 1024 ),
					'PIC_NAME'				=> $row['pic_real_filename'],
					'PIC_RATING'			=> ( $row['rating'] ? round($row['rating'], 2) : $user->lang['GALLERY_NOT_RATED']),
					'PIC_TIME'				=> strftime("%d.%m.%Y %H:%M:%S", $row['pic_time']),
					'PIC_TITLE'				=> $row['pic_title'],
					'PIC_VIEWS'				=> $row['pic_views'],
					'PIC_UPLOADER'			=> $row['pic_username'],
					'PIC_UPLOADER_PROFILE'		=> append_sid("{$phpbb_root_path}memberlist.{$phpEx}?mode=viewprofile&amp;u=" . $row['pic_user_id']),

					'S_IS_PHOTO'			=> true,

					'U_PIC_LINK'			=> append_sid("viewpic.$phpEx?pic_id=" . $row['pic_id']),
					'U_ALBUM_LINK'			=> append_sid("menu.{$phpEx}", 'gallery=members&amp;album_id=' . $row['album_id']),
					'U_PIC_SRC'				=> "pic.{$phpEx}?mode=small&amp;pic_id=" . $row['pic_id'],
							)
						);

				if (!($step % 5))
					{
						$template->assign_block_vars('picsrow', array());
					}
			}
		while ($row = $db->sql_fetchrow($result));
	}

	$leftover = $step % 5;
	for ($i = $leftover; $i < 5; $i++)
		{
			$template->assign_block_vars('picsrow.picscolumn', array(
				'S_IS_PHOTO'		=> false
				)
			);
		}

	if ($start < 0 || $start > $total_pics)
		{
			$start = ($start < 0) ? 0 : floor(($total_pics - 1) / $pics_per_page) * $pics_per_page;
		}

	$pagination = generate_pagination(append_sid("recent.{$phpEx}"), $total_pics, $pics_per_page, $start);
	$template->assign_vars(array(
		'PAGE_NUMBER' 	=> on_page($total_pics, $pics_per_page, $start),	
		'PAGINATION' 	=> $pagination,
		'TOTAL_PICS'	=> ($total_pics == 1) ? $user->lang['GALLERY_PG_PICTURE'] : sprintf($user->lang['GALLERY_PG_PICTURES'], $total_pics),
			)
		);	

$db->sql_freeresult($result);
}
else //if user post count is too low
	{
		$remaining = $min_posts - $has_posted;
		if ($remaining == 1)
			{
				$s = '';
			}
		else
			{
				$s = 's';
			}
		$redirect_url = append_sid("{$phpbb_root_path}index.{$phpEx}");
		$redirect_message = sprintf($user->lang['REQUIRED_POSTS'], $remaining) . $s . '<br />&nbsp;<br />' . sprintf($user->lang['GALLERY_REDIRECT_TO_FORUM_MSG'], $redirect_url);
		$gallery->redirect($redirect_url, $redirect_message, 10);
	}
// Menu
$gallery->generate_menu(GALLERY_PAGE_RECENT);

// Output the page
page_header($user->lang['GALLERY_TITLE']);

$template->set_filenames(array(
    'body' => 'gallery/gallery_output.html')
);

page_footer();
?>