<?php
/**
*
* @package TS Gallery
* @version $Id: upload.php v0.1.1 03.12.2007 20:08:03 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../'; //relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include_once($phpbb_root_path . 'includes/functions_upload.' . $phpEx);
include($phpbb_root_path . 'includes/gallery.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// language file
$user->setup('mods/gallery');
$gallery = new Gallery();
$gallery->load_config();

$min_posts	= (int) $gallery->get_config('comments_to_access');
$has_posted = (int) $user->data['user_posts'];
$guest_access = ($gallery->get_config('guests_can_access')) ? true : false;
if (!$guest_access  && !$user->data['is_registered'])
{
	login_box();
}
if ($min_posts > 0)
	{
		if (!$user->data['is_registered'])
			{
				$can_access = false;
			}	
		else
			{
				if ($has_posted >= $min_posts)
					{
						$can_access = true;
					}
				else
					{
						$can_access = false;
					}
			}
	}
else
	{
		$can_access = true;
	}

// Thats the access sorted

if (!$user->data['is_registered'])
	{
		$visibility = 'none'; // IMPORTANT
		$user_upload = ($gallery->get_config('users_can_upload')) ? true : false;
		if ($user_upload)
			{
				$can_upload = ($gallery->get_config('guests_can_upload')) ? true : false;
			}
		else
			{
				$can_upload = false;
			}
	}
else
	{
		$visibility = 'visible';
		$can_upload = ($gallery->get_config('users_can_upload')) ? true : false;
	}

if (!$can_upload || !$can_access)
	{
		$redirect_url = append_sid("../index.{$phpEx}");
		$redirect_message = $user->lang['GALLERY_ADMIN_ONLY'] . '<br />&nbsp;<br />' . sprintf($user->lang['GALLERY_REDIRECT_TO_FORUM_MSG'], $redirect_url);
		$gallery->redirect($redirect_url, $redirect_message, 10);
	}

$upload = isset($_POST['upload']) ? true : false;

if ($upload)
{
		
	$album_id		= request_var('album_id', -1);
	$title 		= utf8_normalize_nfc(request_var('pictitle', '', true));
	$description	= utf8_normalize_nfc(request_var('piccomment', '', true));
	
	$filedata 		= $gallery->handle_upload();
	
	if (!sizeof($filedata['error']))
	{
		if($album_id == -1)
		{
			trigger_error($user->lang['L_GALLERY_INVALID_ALBUM_ID']);
		}
		else if ($album_id == 0)
		{
			if ($user->data['is_registered'])
				{
					$sql = 'SELECT album_id  
						FROM ' . GALLERY_ALBUMS_TABLE . ' 
						WHERE album_user_id = ' . $user->data['user_id'];
				}
			else
				{
					$album_name = $user->lang['GUEST_ALBUM_NAME'];
					$sql = 'SELECT album_id
						FROM ' . GALLERY_ALBUMS_TABLE . " 
						WHERE album_user_id = 0
						AND album_name = '$album_name' ";
				}
			$result = $db->sql_query($sql);
			if (!$row = $db->sql_fetchrow($result))
				{
					if ($user->data['is_registered'])
						{
							$album_name = $user->data['username'];
							$album_user_id = $user->data['user_id'];
							$sql_array = array (
								'album_name'		=> $album_name,
								'album_user_id'		=> $album_user_id
										);
				
							$db->sql_query('INSERT INTO  ' . GALLERY_ALBUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array));
							$upload_album_id = $db->sql_nextid();
						}
					else
						{
							$album_name = $user->lang['GUEST_ALBUM_NAME'];
							$album_user_id = 0;
							$sql_array = array (
								'album_name'		=> $album_name,
								'album_user_id'		=> $album_user_id
								);
				
							$db->sql_query('INSERT INTO  ' . GALLERY_ALBUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array));
							$upload_album_id = $db->sql_nextid();
						}

				}
			else
				{
					$upload_album_id = $row['album_id'];
				}
						
						
			$sql_array = array(
				'pic_album_id'				=> $upload_album_id,
				'pic_physical_filename'			=> $filedata['physical_filename'],
				'pic_real_filename'			=> $filedata['real_filename'],
				'pic_filesize'				=> $filedata['filesize'],
				'pic_mimetype'				=> $filedata['mimetype'],
				'pic_title'					=> $title,
				'pic_desc'					=> $description,
				'pic_user_id'				=> $user->data['user_id'],
				'pic_username'				=> $user->data['username'],
				'pic_user_ip'				=> $user->data['user_ip'],
				'pic_time'					=> $filedata['filetime']
			);
			$db->sql_query('INSERT INTO ' . GALLERY_PICS_TABLE . $db->sql_build_array('INSERT', $sql_array));
		}
		else
		{
			$upload_album_id = $album_id;
			$sql_array = array(
				'pic_album_id'				=> $upload_album_id,
				'pic_physical_filename'			=> $filedata['physical_filename'],
				'pic_real_filename'			=> $filedata['real_filename'],
				'pic_filesize'				=> $filedata['filesize'],
				'pic_mimetype'				=> $filedata['mimetype'],
				'pic_title'					=> $title,
				'pic_desc'					=> $description,
				'pic_user_id'				=> $user->data['user_id'],
				'pic_username'				=> $user->data['username'],
				'pic_user_ip'				=> $user->data['user_ip'],
				'pic_time'					=> $filedata['filetime']
			);
			
			$db->sql_query('INSERT INTO ' . GALLERY_PICS_TABLE . $db->sql_build_array('INSERT', $sql_array));
		}

		$redir_pic_id		= $db->sql_nextid();
		$redirect_url		= append_sid("viewpic.{$phpEx}?pic_id={$redir_pic_id}");
		$redirect_alt_url	= append_sid('menu.php?gallery=' . ($album_id == 0 ? 'members' : 'public') . "&amp;album_id={$upload_album_id}");
		$redirect_message	= sprintf($user->lang['GALLERY_FILE_UPLOADED'] . '<br /><br />' . $user->lang['GALLERY_UPLOAD_REDIRECT_MSG'], $redirect_url, $redirect_alt_url); 
		$gallery->redirect($redirect_url, $redirect_message, 7);
	}
	else
	{
		$error_message = '';
		foreach ($filedata['error'] as $error)
		{
			$error_message .= $error . '<br />';
		}
		$redirect_url = append_sid("upload.{$phpEx}");
		$redirect_message = $error_message . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url);
		$gallery->redirect($redirect_url, $redirect_message, 10);
	}
}

$template->assign_vars(array(
	'L_GALLERY_TITLE'					=> $user->lang['GALLERY_TITLE'],
	'U_ACTION'						=> append_sid("upload.{$phpEx}"),
	'U_VISIBILITY'					=> $visibility,
	'L_GALLERY_UPLOAD_TO_ALBUM'			=> $user->lang['GALLERY_UPLOAD_TO'],
	'L_GALLERY_UPLOAD_TO_ALBUM_OPTIONS'		=> $gallery->get_albums(),
	'L_GALLERY_UPLOAD_FILE'				=> $user->lang['GALLERY_PICTURE_TO_UPLOAD'],
	'L_GALLERY_UPLOAD_TITLE'			=> $user->lang['GALLERY_PICTURE_TITLE'],
	'L_GALLERY_UPLOAD_DESCRIPTION'		=> $user->lang['GALLERY_PICTURE_DESCRIPTION']
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> ( (int) $gallery->get_config('jpg_allowed') == 1 ? sprintf($user->lang['GALLERY_ALLOWED_UPLOAD_FILETYPE'], '<strong>JPG</strong>') : '' )
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> ( (int) $gallery->get_config('gif_allowed') == 1 ? sprintf($user->lang['GALLERY_ALLOWED_UPLOAD_FILETYPE'], '<strong>GIF</strong>') : '' )
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> ( (int) $gallery->get_config('png_allowed') == 1 ? sprintf($user->lang['GALLERY_ALLOWED_UPLOAD_FILETYPE'], '<strong>PNG</strong>') : '' )
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> $user->lang['GALLERY_MAX_FILESIZE'] . ': <strong>' . floor( (float) $gallery->get_config('max_filesize') / 1024 ). '</strong> (KB)'
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> $user->lang['GALLERY_MAX_WIDTH'] . ': <strong>' . $gallery->get_config('max_width') . '</strong> (' .$user->lang['GALLERY_PIXELS'] . ')'
	)
);

$template->assign_block_vars('upload_info_block', array(
	'INFO'	=> $user->lang['GALLERY_MAX_HEIGHT'] . ': <strong>' . $gallery->get_config('max_height') . '</strong> (' .$user->lang['GALLERY_PIXELS'] . ')'
	)
);

// Menu
$gallery->generate_menu(GALLERY_PAGE_UPLOAD);

// Output the page
page_header($user->lang['GALLERY_TITLE']);

$template->set_filenames(array(
    'body' => 'gallery/gallery_upload.html')
);

page_footer();
?>