<?php
/**
*
* @package TS Gallery
* @version $Id: viewpic.php v0.1.1 02.12.2007 00:02:37 uber geek Exp $
* @copyright (c) uber geek - http://threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';//relative path to phpBB3 forum directory
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/gallery.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// language file
$user->setup('mods/gallery');
$gallery = new Gallery();

$gallery->load_config();


$min_posts	= (int) $gallery->get_config('comments_to_access');
if ($min_posts > 0 && !$user->data['is_registered'])
	{
		login_box();
	}
elseif (!$user->data['is_registered'])
	{
		$guest_access = ($gallery->get_config('guests_can_access')) ? true : false;
		if (!$guest_access)
			{
				login_box();
			}
	}

if ($min_posts > 0 && $user->data['is_registered'])
	{
		$has_posted = (int) $user->data['user_posts'];
		if ($has_posted < $min_posts)
			{
				$remaining = $min_posts - $has_posted;
				if ($remaining == 1)
					{
						$s = '';
					}
				else
					{
						$s = 's';
					}
				$redirect_url = append_sid("{$phpbb_root_path}index.{$phpEx}");
				$redirect_message = sprintf($user->lang['REQUIRED_POSTS'], $remaining) . $s . '<br />&nbsp;<br />' . sprintf($user->lang['GALLERY_REDIRECT_TO_FORUM_MSG'], $redirect_url);
				$gallery->redirect($redirect_url, $redirect_message, 10);
			}
	}

$comments_per_page = (int) $gallery->get_config('comments_per_page');

$min_posts_to_post = (int) $gallery->get_config('comments_to_post');

if ($min_posts_to_post > 0)
	{
 		if (!$user->data['is_registered'])
			{
				$pass_post_limit = false;
			}
		else 
			{
				if ($has_posted >= $min_posts_to_post)
					{
						$pass_post_limit = true;
					}
				else
					{
						$pass_post_limit = false;
					}
			}
	}
else
	{
		$pass_post_limit = true;
	}

if ($pass_post_limit)
	{
		if (!$user->data['is_registered'])
			{
				$user_comment = ($gallery->get_config('users_can_comment')) ? true : false;
				$guest_comment = ($gallery->get_config('guests_can_comment')) ? true : false;
				if ($user_comment && $guest_comment)
					{
						$can_comment = true;
					}
				else
					{
						$can_comment = false;
					}
				$comments_need_approval	= ($gallery->get_config('comments_need_approval')) ? true : false;
				$guests_need_approval	= ($gallery->get_config('guests_need_approval')) ? true : false;
				if (!$comments_need_approval && !$guests_need_approval)
					{
						$comments_need_approval = false;
					}
				else
					{
						$comments_need_approval = true;
					}
			}
		else
			{
				$can_comment = ($gallery->get_config('users_can_comment')) ? true : false;
				$comments_need_approval	= ($gallery->get_config('comments_need_approval')) ? true : false;		
			}
	}
else
	{
		$can_comment = false;
		$comments_need_approval = true;
	}

$site_url = generate_board_url();
$pic_id = (int) request_var('pic_id', 0);
$approve = (int) request_var('approve', 0);
if ($approve !== 0 && $auth->acl_gets('a_', 'm_'))
	{
		$sql = 'SELECT comment_approved				
				FROM ' . GALLERY_COMMENT_TABLE . '
				WHERE comment_id = ' . $approve;
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
				{
					$db->sql_freeresult($result);
					$db->sql_query('UPDATE ' . GALLERY_COMMENT_TABLE . " SET comment_approved = 1 WHERE comment_id = $approve");
				}
			else
				{
					trigger_error('APPROVAL FAILED');
				}
	}

$pic_data	= array();

$sql = 'SELECT p.*, r.rate_pic_id, AVG(r.rate_point) AS rating, COUNT(DISTINCT c.comment_id) AS comments, a.*		
	FROM ' . GALLERY_PICS_TABLE . ' AS p
		LEFT JOIN ' . GALLERY_RATE_TABLE . ' AS r ON p.pic_id = r.rate_pic_id 
		LEFT JOIN ' . GALLERY_COMMENT_TABLE . ' AS c ON p.pic_id = c.comment_pic_id
		LEFT JOIN ' . GALLERY_ALBUMS_TABLE . " AS a ON a.album_user_id = p.pic_user_id 
		WHERE pic_id = $pic_id		
		GROUP BY p.pic_id";
$result = $db->sql_query($sql);
if (!$row = $db->sql_fetchrow($result))
	{
		$redirect_url = append_sid("menu.{$phpEx}");
		$redirect_message	= $user->lang['GALLERY_PIC_ID_NOT_FOUND'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_TO_INDEX_MSG'], $redirect_url); 
		$gallery->redirect($redirect_url, $redirect_message, 7);
	}
else
	{
		$pic_data = $row;
		$db->sql_freeresult($result);
		$db->sql_query('UPDATE ' . GALLERY_PICS_TABLE . " SET pic_views = pic_views + 1 WHERE pic_id = $pic_id");
			
		if ($user->data['is_registered'])
			{
				$sql = 'SELECT rate_point				
					FROM ' . GALLERY_RATE_TABLE . '
					WHERE rate_user_id = ' . $user->data['user_id'] . "
					AND  rate_pic_id = $pic_id";
				$result = $db->sql_query($sql);
				if ($row = $db->sql_fetchrow($result))
					{
						$pic_data = array_merge($pic_data, array('can_rate' => false, 's_rated' => true, 'rate_point' => (int) $row['rate_point']));
					}
				else
					{
						$pic_data = array_merge($pic_data, array('can_rate' => true, 's_rated' => false, 'rate_point' => 0));
					}
			}
		else
			{
				$pic_data = array_merge($pic_data, array('can_rate' => false, 's_rated' => false, 'rate_point' => 0));
			}
	
$submit = isset($_POST['submit']) ? true : false;
if ($submit)
	{
		if ($comments_need_approval)
			{
				$approved = 0;
			}
		else
			{
				$approved = 1;
			}
		if (!$user->data['is_registered'])
			{
				$username = 'Guest';
			}
		else
			{
				$username = $user->data['username'];
			}
				$is_rate = isset($_POST['rate']) ? true : false;
				if ($is_rate)
					{
						if ($pic_data['s_rated'])
							{
								$redirect_url = append_sid("viewpic.{$phpEx}?pic_id={$pic_id}");
								$redirect_message	= $user->lang['GALLERY_ALREADY_RATED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
								$gallery->redirect($redirect_url, $redirect_message, 7);
							}
						else
							{
								$rate_point = (int) request_var('rate', 0);
								if ($rate_point > 0 && $rate_point <= 10)
									{
										$sql_array = array (
											'rate_pic_id'	=> $pic_id,
											'rate_user_id'	=> $user->data['user_id'],
											'rate_user_ip'	=> $user->data['user_ip'],
											'rate_point'	=> $rate_point
													);
						
										$db->sql_query('INSERT INTO  ' . GALLERY_RATE_TABLE . $db->sql_build_array('INSERT', $sql_array));
										$redirect_url = append_sid("viewpic.{$phpEx}?pic_id={$pic_id}");
										$redirect_message	= $user->lang['GALLERY_RATING_ADDED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
										$gallery->redirect($redirect_url, $redirect_message, 7);
									}
							}
					}
			
				$is_comment = isset($_POST['comment']) ? true : false;
				if ($is_comment)
					{					
						$comment = request_var('comment', '', true);
						if ($comment != '')
							{
								$sql = 'SELECT pic_album_id				
									FROM ' . GALLERY_PICS_TABLE . '
									WHERE pic_id = ' . $pic_id;
								$result = $db->sql_query($sql);
								if ($row = $db->sql_fetchrow($result))
									{
										$uid = $bitfield = $flags = '';
										$allow_bbcode = $allow_urls = $allow_smilies = true;
										generate_text_for_storage($comment, $uid, $bitfield, $flags, $allow_bbcode, $allow_urls, $allow_smilies);
										$sql_array = array (
											'comment_pic_id'			=> $pic_id,
											'comment_album_id'		=> $row['pic_album_id'],
											'comment_user_id'			=> $user->data['user_id'],
											'comment_user_ip'			=> $user->data['user_ip'],
											'comment_time'			=> time(),
											'comment_username'		=> $username,
											'comment_text'			=> $comment,
											'comment_bbcode_bitfield'	=> $bitfield,
											'comment_bbcode_uid'		=> $uid,
											'comment_bbcode_flags'		=> $flags,
											'comment_approved'		=> $approved
												);
										$db->sql_query('INSERT INTO  ' . GALLERY_COMMENT_TABLE . $db->sql_build_array('INSERT', $sql_array));
									}
								$redirect_url = append_sid("viewpic.{$phpEx}?pic_id={$pic_id}");
								$redirect_message	= $user->lang['GALLERY_COMMENT_ADDED'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
								$gallery->redirect($redirect_url, $redirect_message, 7);
							}
						else
							{
								$redirect_url		= append_sid("viewpic.{$phpEx}?pic_id={$pic_id}");
								$redirect_message	= $user->lang['GALLERY_COMMENT_IS_EMPTY'] . '<br />' . sprintf($user->lang['GALLERY_REDIRECT_GO_BACK'], $redirect_url); 
								$gallery->redirect($redirect_url, $redirect_message, 7);
							}
					}
				$redirect_url = append_sid("viewpic.{$phpEx}?pic_id={$pic_id}");
				$gallery->redirect($redirect_url, ':)', 2);
		
	}
else
	{
		$prev_pic = $gallery->get_prev_pic($pic_id, $pic_data['pic_album_id']);
			if ($prev_pic == 0)
				{
					$no_prev = true;
				}
		$next_pic = $gallery->get_next_pic($pic_id, $pic_data['pic_album_id']);
			if ($next_pic == 0)
				{
					$no_next = true;
				}

$delete_img_auth = ($gallery->get_config('users_can_delete_images')) ? true : false;
if ($delete_img_auth && $user->data['user_id'] == $pic_data['pic_user_id'] || $auth->acl_gets('a_', 'm_'))
	{
		if (!$user->data['is_registered'])
			{
				$can_delete_img = false;
			}
		else
			{
				$can_delete_img = true;
			}
	}
else
	{
		$can_delete_img = false;
	}

if ($pic_data['album_user_id'] > 0)
	{
		$user_allow_comments = ($pic_data['album_allow_comments']) ? true : false;
	}
else
	{
		$user_allow_comments = true;
	}

		$template->assign_vars(array(

			'GALLERY_YOU_RATED'		=> $pic_data['rate_point'],

			'L_GALLERY_TITLE'			=> $user->lang['GALLERY_TITLE'],
			'L_GALLERY_PIC_RATE'		=> $user->lang['GALLERY_RATE_THIS_PIC'],
			'L_GALLERY_DELETE_IMAGE'	=> $user->lang['GALLERY_DELETE_IMAGE'],
			'L_PIC_RATING'			=> $user->lang['GALLERY_RATING'],
			'L_PIC_VIEWS'			=> $user->lang['GALLERY_VIEWS'],
			'L_GALLERY_YOU_RATED'		=> $user->lang['GALLERY_YOU_RATED'],
			'L_PIC_UPLOADED_BY'		=> $user->lang['GALLERY_UPLOADED_BY'],
			'L_PIC_ON'				=> $user->lang['GALLERY_UPLOADED_ON_DATE'],
			'L_PIC_COMMENTS'			=> $user->lang['GALLERY_COMMENTS'],
			'L_PIC_FILESIZE'			=> $user->lang['GALLERY_SIZE'],
			'L_PIC_BBCODE_LINK'		=> $user->lang['GALLERY_BBCODE_LINK'],
			'L_PIC_SHARE_LINK'		=> $user->lang['GALLERY_SHARE_LINK'],
			'L_VISIT_GALLERY'			=> $user->lang['GALLERY_VISIT_GALLERY'],

			'NO_PREV'				=> $no_prev,
			'NO_NEXT'				=> $no_next,

			'PIC_NAME'				=> $pic_data['pic_real_filename'],
			'PIC_BBCODE_LINK'			=> '[url=' . $site_url . '/gallery/viewpic.' . $phpEx . '?pic_id=' . $pic_id . '][img]' . $site_url . '/gallery/pic.' . $phpEx . '?mode=small&amp;pic_id=' . $pic_id . '[/img][/url]',
			'PIC_SHARE_LINK'			=> "{$site_url}/gallery/pic.{$phpEx}?mode=large&amp;pic_id={$pic_id}",
			'PIC_COMMENTS'			=> $pic_data['comments'],
			'PIC_RATING'			=> ( $pic_data['rating'] ? round($pic_data['rating'], 2) : 'Not rated yet.'),
			'PIC_VIEWS'				=> $pic_data['pic_views'],
			'PIC_FILESIZE'			=> floor( (float) $pic_data['pic_filesize'] / 1024 ),
			'PIC_TIME'				=> strftime("%d.%m.%Y %H:%M:%S", $pic_data['pic_time']),
			'PIC_UPLOADER'			=> $pic_data['pic_username'],
			'PIC_TITLE'				=> $pic_data['pic_title'],
			'PIC_DESC'           		=> $pic_data['pic_desc'],
			'PIC_UPLOADER_PROFILE'		=> append_sid("{$phpbb_root_path}memberlist.{$phpEx}", "mode=viewprofile&amp;u=" . $pic_data['pic_user_id']),
			'PIC_UPLOADER_ALBUM'		=> append_sid("menu.{$phpEx}", "gallery=members&amp;album_id=" . $pic_data['pic_album_id']),

			'S_CAN_COMMENT'			=> $can_comment,
			'S_CAN_DELETE_PIC'		=> $can_delete_img,
			'S_CAN_RATE'			=> $pic_data['can_rate'],
			'S_RATED'				=> $pic_data['s_rated'],

			'U_PIC_LINK'			=> "pic.{$phpEx}?mode=large&amp;pic_id={$pic_id}",
			'U_PREV_SRC'			=> "pic.{$phpEx}?mode=small&amp;pic_id={$prev_pic}",
			'U_NEXT_SRC'			=> "pic.{$phpEx}?mode=small&amp;pic_id={$next_pic}",
			'U_PIC_SRC'				=> "pic.{$phpEx}?mode=med&amp;pic_id={$pic_id}",
			'U_IMAGE_DELETE'			=> append_sid("image_drop.{$phpEx}?image_id={$pic_data['pic_physical_filename']}&amp;i={$pic_id}&amp;mode=delete"),
			'U_PREV_PIC'			=> append_sid("{$phpbb_root_path}gallery/viewpic.{$phpEx}", "pic_id=" . $prev_pic),
			'U_NEXT_PIC'			=> append_sid("{$phpbb_root_path}gallery/viewpic.{$phpEx}", "pic_id=" . $next_pic),

			'USER_ALLOW_COMMENTS' 		=> $user_allow_comments,

			)
		);

// Pagination		
$start = request_var('start', 0);
$sql = 'SELECT COUNT(comment_id) AS num_comments 
	FROM ' . GALLERY_COMMENT_TABLE . "
	WHERE comment_pic_id = $pic_id";
$result = $db->sql_query($sql);
$total_comments = (int) $db->sql_fetchfield('num_comments');

if ($start < 0 || $start > $total_comments)
	{
		$start = ($start < 0) ? 0 : floor(($total_comments - 1) / $comments_per_page) * $comments_per_page;
	}

$pagination = generate_pagination(append_sid("viewpic.$phpEx", "pic_id={$pic_id}" . (($highlight_match) ? "&amp;hilit=$highlight" : '')),  $total_comments, $comments_per_page, $start);


// OLD $pagination = generate_pagination(append_sid("viewpic.$phpEx", "pic_id={$pic_id}"), $total_comments, $comments_per_page, $start);

$template->assign_vars(array(
	'PAGINATION' 	=> $pagination,
	'PAGE_NUMBER' 	=> on_page($total_comments, $comments_per_page, $start),
	'TOTAL_POSTS'	=> ($total_comments == 1) ? $user->lang['GALLERY_PG_COMMENT'] : sprintf($user->lang['GALLERY_PG_COMMENTS'], $total_comments),
				)
			);
//EoP

$sql = 'SELECT c.*, u.*, a.*
	FROM ' . GALLERY_COMMENT_TABLE . ' AS c
	LEFT JOIN ' . USERS_TABLE . ' AS u ON c.comment_user_id = u.user_id 
	LEFT JOIN ' . GALLERY_ALBUMS_TABLE . " AS a ON a.album_user_id = u.user_id  
	WHERE c.comment_pic_id = $pic_id
	ORDER BY c.comment_id ASC";
$result = $db->sql_query_limit($sql, $comments_per_page, $start);

if ($row = $db->sql_fetchrow($result))
	{	
		do
			{
				$poster_album_id = (int) $row['comment_user_id'];
				$gallery_link_id = (int) $row['album_id'];
     				 if ($gallery_link_id > 0)
      				{
       					$gallery_link = true;
     					}
				else
					{
						$gallery_link = false;
					}	

				if ($auth->acl_get('a_') )
					{
						$can_edit = 'true';
						$can_delete = 'true';
					}
				else if ($row['comment_user_id'] == $user->data['user_id'])
					{
						$can_edit  = ($gallery->get_config('users_can_edit_comments')) ? true : false;
						$can_delete  = ($gallery->get_config('users_can_delete_comments')) ? true : false;
					}
				else
					{
						$can_edit = false;
						$can_delete = false;
					}

				get_user_rank($row['user_rank'], $row['user_posts'], $row['rank_title'], $row['rank_image'], $row['rank_image_src']);
	
				if (!empty($row['user_allow_viewemail']) || $auth->acl_get('a_email'))
					{
						$user_email = ($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u=" . $row['comment_user_id']) : (($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']);
					}
				else
					{
						$user_email = '';
					}

				$template->assign_vars(array(
					'COMMENTED' 		=> true,
					'EDIT_IMG' 			=> $user->img('icon_post_edit', 'EDIT_POST'),
					'DELETE_IMG' 		=> $user->img('icon_post_delete', 'DELETE_POST'),
					'PROFILE_IMG'		=> $user->img('icon_user_profile', 'READ_PROFILE'),
					'PM_IMG' 			=> $user->img('icon_contact_pm', 'SEND_PRIVATE_MESSAGE'),
					'EMAIL_IMG' 		=> $user->img('icon_contact_email', 'SEND_EMAIL'),
					'WWW_IMG' 			=> $user->img('icon_contact_www', 'VISIT_WEBSITE'),
					'ICQ_IMG' 			=> $user->img('icon_contact_icq', 'ICQ'),
					'AIM_IMG' 			=> $user->img('icon_contact_aim', 'AIM'),
					'MSN_IMG' 			=> $user->img('icon_contact_msnm', 'MSNM'),
					'YIM_IMG' 			=> $user->img('icon_contact_yahoo', 'YIM'),
					'JABBER_IMG'		=> $user->img('icon_contact_jabber', 'JABBER'),
									)
								);
				$rank_img_src = $row['rank_image'];
				$rank_img_src = preg_replace('/(<i)(.*)(c=")/','<img src="../',$rank_img_src);
				$poster_avatar = ($user->optionget('viewavatars')) ? get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']) : '';
				$poster_avatar = preg_replace('#(./../)#','../',$poster_avatar);

			if ($row['comment_username'] == 'Guest')
				{
					$comments_need_approval = ($gallery->get_config('guests_can_comment')) ? true : false;

					if ($comments_need_approval && $row['comment_approved'] == 0)
						{
							if ($auth->acl_gets('a_', 'm_'))
								{
									$approve = true;
									$message = '<span class="error"><b>' . $user->lang['MOD_APPROVE'] . '</b></span><br />' . generate_text_for_display( $row['comment_text'], $row['comment_bbcode_uid'],  $row['comment_bbcode_bitfield'],  $row['comment_bbcode_flags']) ;
								}
							else
								{
									$message = '<span class="error"><b>' . $user->lang['AWAITING_APPROVAL'] . '</b></span>';
								}
						}
					else
						{
							$message = generate_text_for_display( $row['comment_text'], $row['comment_bbcode_uid'],  $row['comment_bbcode_bitfield'],  $row['comment_bbcode_flags']);
						}

							$template->assign_block_vars('postrow', array(
								'L_POSTED_ON_DATE'		=> $user->lang['POSTED_ON_DATE'],
								'L_POST_BY_AUTHOR'		=> $user->lang['GALLERY_POST_BY_AUTHOR'],

								'MINI_POST_IMG'			=> '',
								'MESSAGE'				=> $message,

								'POST_AUTHOR_FULL'		=> $row['comment_username'],
								'POST_DATE'				=> strftime("%d.%m.%Y %H:%M:%S", $row['comment_time']),
								'POSTER_AVATAR'			=> '', // PERHAPS ADD DEFAULT GUEST AVATAR
								'POSTER_JOINED'			=> '',
								'POSTER_POSTS'			=> '',
								'POSTER_FROM'			=> '',
								'POST_ID'				=> $row['comment_id'],

								'S_CAN_EDIT_COMMENT'		=> $can_edit,
								'S_CAN_DELETE_COMMENT'		=> $can_delete,
         							'S_GALLERY_LINK'   		=> false,
								'S_ONLINE'				=> false,
								'S_APPROVE'			 	=> $approve,

								'U_PROFILE'				=> '',
								'U_PM'				=> '',
								'U_EMAIL'				=> '',
								'USER_WWW'				=> '',
								'USER_AIM'				=> '',
								'USER_MSN'				=> '',
								'USER_YIM'				=> '',
								'USER_JABBER'			=> '',
								'U_POST_AUTHOR'			=> '',

								// Leave edit and delete links for Admin use
								'U_EDIT'				=> append_sid("edit_post.{$phpEx}?mode=edit&amp;p={$row['comment_id']}&amp;i={$pic_id}"), 
								'U_DELETE'				=> append_sid("edit_post.{$phpEx}?mode=delete&amp;p={$row['comment_id']}&amp;i={$pic_id}"),
								'U_GALLERY_LINK_ID'   		=> '',
								'U_APPROVE' 	  		=> append_sid("viewpic.$phpEx", 'approve=' . $row['comment_id'] . '&amp;pic_id=' . $pic_id),
												)
											);
				}
			else
				{
					if ($comments_need_approval && $row['comment_approved'] == 0 && !$auth->acl_gets('a_', 'm_') )
						{
							$message = $user->lang['AWAITING_APPROVAL'];
						}
					else
						{
							$message = generate_text_for_display( $row['comment_text'], $row['comment_bbcode_uid'],  $row['comment_bbcode_bitfield'],  $row['comment_bbcode_flags']);
						}
					$template->assign_block_vars('postrow', array(
						'L_POSTED_ON_DATE'		=> $user->lang['POSTED_ON_DATE'],
						'L_POST_BY_AUTHOR'		=> $user->lang['GALLERY_POST_BY_AUTHOR'],

						'MINI_POST_IMG'			=> $user->img('icon_post_target', 'POST'),
						'MESSAGE'				=> $message,

						'POST_AUTHOR_FULL'		=> $row['comment_username'],
						'POST_DATE'				=> strftime("%d.%m.%Y %H:%M:%S", $row['comment_time']),
						'POSTER_AVATAR'			=> $poster_avatar,
						'POSTER_JOINED'			=> $user->format_date($row['user_regdate']),
						'POSTER_POSTS'			=> $row['user_posts'],
						'POSTER_FROM'			=> (!empty($row['user_from'])) ? $row['user_from'] : '',
						'POST_ID'				=> $row['comment_id'],

						'RANK_TITLE'			=> $row['rank_title'],
						'RANK_IMG'				=> $rank_img_src,
						'RANK_IMG_SRC'			=> '',

						'S_CAN_EDIT_COMMENT'		=> $can_edit,
						'S_CAN_DELETE_COMMENT'		=> $can_delete,
         					'S_GALLERY_LINK'   		=> $gallery_link,
						'S_ONLINE'				=> false,

						'U_PROFILE'				=> append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=viewprofile&amp;u=" . $row['comment_user_id']),
						'U_PM'				=> ($poster_id != ANONYMOUS && $config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['comment_user_id']) : '',
						'U_EMAIL'				=> $user_email,
						'USER_WWW'				=> $row['user_website'],
						'USER_AIM'				=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u=$poster_id") : '',
						'USER_MSN'				=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u=$poster_id") : '',
						'USER_YIM'				=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
						'USER_JABBER'			=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u=$poster_id") : '',
						'U_POST_AUTHOR'			=> append_sid("{$phpbb_root_path}memberlist.{$phpEx}", "mode=viewprofile&amp;u=" . $row['comment_user_id']),
						'U_EDIT'				=> append_sid("edit_post.{$phpEx}?mode=edit&amp;p={$row['comment_id']}&amp;i={$pic_id}"),
						'U_DELETE'				=> append_sid("edit_post.{$phpEx}?mode=delete&amp;p={$row['comment_id']}&amp;i={$pic_id}"),
						'U_GALLERY_LINK_ID'   		=> append_sid("menu.$phpEx", 'gallery=members&album_id=' . $gallery_link_id),
						'U_APPROVE' 	  		=> append_sid("viewpic.$phpEx", 'approve=' . $row['comment_id']),
						)
					);
				}
			} 
		while ($row = $db->sql_fetchrow($result));
		}

generate_smilies('inline', false);
		
	}		
}

// Menu
$gallery->generate_menu(GALLERY_PAGE_VIEWPIC);

// Output the page
page_header($user->lang['GALLERY_TITLE']);

$template->set_filenames(array(
    'body' => 'gallery/gallery_viewpic.html')
);

page_footer();
?>