<?php
/**
*
* @package TS Gallery
* @version $Id: acp_gallery.php,v 0.1.1 2007/11/30 14:15:10 uber geek Exp $
* @copyright (c) 2007 threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package TS Gallery
*/

class acp_gallery
{
	var $u_action;
					
	function main($id, $mode)
	{
		global $user;
					
		$user->add_lang('mods/gallery');
							
		// Set up the page
		$this->tpl_name 		= 'acp_gallery';
		$this->page_title 	= 'ACP_GALLERY_' . strtoupper($mode);
		
		switch ($mode)
		{
			case 'manage_albums':

				$action = request_var('action', '');

				switch ($action) 
				{
					case 'move_up':
						$this->move_album('move_up');
					break;
					
					case 'move_down':
						$this->move_album('move_down');
					break;
					
					case 'edit':
						$this->edit_album();
					break;
					
					case 'delete':
						$this->delete_album();
					break;
					
					default:
						$this->manage_albums();
					break;
				}
			
			break;

			case 'create_album':
				$this->create_album();
			break;
			
			case 'manage_cache':
				$this->manage_cache();
			break;
			
			case 'general_settings':
				$this->general_settings();
			break;

			case 'user_settings':
				$this->user_settings();
			break;

			case 'guest_settings':
				$this->guest_settings();
			break;
		}
	}	
		
	function move_album($action = 'move_up')
	{
		global $db, $user;

		$album = isset($_GET['album_id']) ? true : false;
		
		if ($album)
		{
			$album_id = (int) request_var('album_id', 0);

			$sql = 'SELECT album_id, album_parent_id, album_left_id, album_right_id
					FROM ' . GALLERY_ALBUMS_TABLE . "
					WHERE album_id = $album_id 
						AND album_user_id = 0";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			
			if ($row)
			{
				$move_album_parent_id	= (int) $row['album_parent_id'];
				$move_album_id			= (int) $row['album_id'];
				$move_left_id			= (int) $row['album_left_id'];
				$move_right_id			= (int) $row['album_right_id'];
				$sql = 'SELECT album_id, album_left_id, album_right_id
						FROM ' . GALLERY_ALBUMS_TABLE . "
						WHERE album_parent_id = $move_album_parent_id 
							AND album_user_id = 0
								AND " . (($action == 'move_up') ? "album_right_id < $move_right_id ORDER BY album_right_id DESC" : "album_left_id > $move_left_id ORDER BY album_left_id ASC");
				$result = $db->sql_query_limit($sql, 1);
				if ($row = $db->sql_fetchrow($result))
				{
					$to_move_id			= $row['album_id'];
					$to_move_left_id	= $row['album_left_id'];
					$to_move_right_id	= $row['album_right_id'];
					
					$sql_array = array (
						'album_left_id'		=> $move_left_id,
						'album_right_id'	=> $move_right_id
					);
					$db->sql_query('UPDATE ' . GALLERY_ALBUMS_TABLE . '
									SET ' . $db->sql_build_array('UPDATE', $sql_array) . "
										WHERE album_id = $to_move_id");

					$sql_array = array (
						'album_left_id'		=> $to_move_left_id,
						'album_right_id'	=> $to_move_right_id
					);
					$db->sql_query('UPDATE ' . GALLERY_ALBUMS_TABLE . '
									SET ' . $db->sql_build_array('UPDATE', $sql_array) . "
										WHERE album_id = $move_album_id");
										
					$this->manage_albums();
				} 
				$db->sql_freeresult($result);
				
			}
			else
			{
				trigger_error($user->lang['GALLERY_INVALID_ALBUM_ID_MSG'], E_USER_WARNING);
			}
		}
		else
		{
			trigger_error($user->lang['GALLERY_MISSING_ALBUM_ID_MSG'], E_USER_WARNING);
		}
	}
	
	function edit_album()
	{
		global $db, $template, $user;
		
		$update = isset($_POST['update']) ? true : false;
		$album = isset($_GET['album_id']) ? true : false;
			
		if ($album)
		{
			$album_id = (int) request_var('album_id', 0);
			
			if ($update)
			{
				$parent_id		= (int) request_var('parent', 0);
				$name			= utf8_normalize_nfc(request_var('name', '', true));
				$description	= utf8_normalize_nfc(request_var('description', '', true));
				
				$sql_array = array (
					'album_parent_id'	=> $parent_id,
					'album_name'	=> $name,
					'album_desc'	=> $description
				);
				
				$db->sql_query('UPDATE ' . GALLERY_ALBUMS_TABLE . '
								SET ' . $db->sql_build_array('UPDATE', $sql_array) . '
									WHERE album_id = ' . $album_id);
				trigger_error($user->lang['GALLERY_ALBUM_UPDATED_MSG']);
			}
			else
			{
				$sql = 'SELECT album_id, album_parent_id, album_name, album_desc
						FROM ' . GALLERY_ALBUMS_TABLE . "
							WHERE album_id = $album_id 
								AND album_user_id = 0";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				
				$album_id 		= (int) $row['album_id'];
				$album_parent_id	= (int) $row['album_parent_id'];
				$template->assign_vars(array(
					'S_GALLERY_MANAGEMENT'	=> true,
					'S_GALLERY_EDIT_ALBUM'	=> true,
					'L_GALLERY_TITLE'		=> $user->lang['GALLERY_EDIT_ALBUMS_TITLE'],
					'L_GALLERY_EXPLAIN'	=> $user->lang['GALLERY_EDIT_ALBUMS_EXPLAIN'],
					'U_ACTION'			=> $this->u_action . '&amp;action=edit&amp;album_id=' . $album_id,
					'L_ALBUM_SETTINGS'	=> $user->lang['GALLERY_ALBUM_SETTINGS'],
					'L_ALBUM_PARENT'		=> $user->lang['GALLERY_PARENT'],
					'ALBUM_PARENT_OPTIONS'	=> $this->get_parents($album_id, $album_parent_id),
					'L_ALBUM_NAME'		=> $user->lang['GALLERY_NAME'],
					'ALBUM_NAME'		=> $row['album_name'],
					'L_ALBUM_DESCRIPTION'	=> $user->lang['GALLERY_DESCRIPTION'],
					'ALBUM_DESCRIPTION'	=> $row['album_desc']				
					)
				);
			}	
		}
		else
		{
			trigger_error($user->lang['GALLERY_MISSING_ALBUM_ID_MSG'], E_USER_WARNING);
		}
	}
	
	function delete_album()
	{
		global $db, $template, $user;
		
		$album = isset($_GET['album_id']) ? true : false;
		
		if ($album)
		{
			$delete		= isset($_POST['delete']) ? true : false;
			$album_id	= (int) request_var('album_id', 0);

			$sql = 'SELECT album_parent_id, album_name, album_desc
					FROM ' . GALLERY_ALBUMS_TABLE . "
					WHERE album_user_id = 0 
						AND album_id = $album_id";
			$result = $db->sql_query($sql);

			if ($row = $db->sql_fetchrow($result))
			{
				$album_name			= $row['album_name'];
				$album_description	= $row['album_desc'];

				if ($delete)
				{
					$content_action = request_var('album_id', 'delete');
					
					if ($content_action == 'move')
					{
						$new_album_id = (int) request_var('new_album_id', 0);

						$sql_array = array('album_parent_id' => $new_album_id);
						$db->sql_query('UPDATE ' . GALLERY_ALBUMS_TABLE . '
										SET ' . $db->sql_build_array('UPDATE', $sql_array) . "
										WHERE album_parent_id = $album_id");

						$sql_array = array('pic_album_id' => $new_album_id);
						$db->sql_query('UPDATE ' . GALLERY_PICS_TABLE . '
										SET ' . $db->sql_build_array('UPDATE', $sql_array) . "
										WHERE pic_album_id = $album_id");
					}
					else
					{
						$sql = 'DELETE FROM ' . GALLERY_ALBUMS_TABLE . "
								WHERE album_parent_id = $album_id";
						$result = $db->sql_query($sql);

						$sql = 'DELETE FROM ' . GALLERY_PICS_TABLE . "
								WHERE pic_album_id = $album_id";
						$result = $db->sql_query($sql);
					}					
					$sql = 'DELETE FROM ' . GALLERY_ALBUMS_TABLE . "
							WHERE album_id = $album_id";
					$result = $db->sql_query($sql);

					trigger_error($user->lang['GALLERY_ALBUM_DELETED_MSG']);
				}
				else
				{
					$sql = 'SELECT * 
							FROM ' . GALLERY_ALBUMS_TABLE . "
							WHERE album_parent_id = $album_id";
					$result = $db->sql_query_limit($sql, 1);
					$has_subalbums = ($row = $db->sql_fetchrow($result)) ? true : false;
					$db->sql_freeresult($result);

					$sql = 'SELECT * 
							FROM ' . GALLERY_PICS_TABLE . "
							WHERE pic_album_id = $album_id";
					$result = $db->sql_query_limit($sql, 1);
					$has_pictures = ($row = $db->sql_fetchrow($result)) ? true : false;
					$db->sql_freeresult($result);
					
					$has_content = ($has_subalbums || $has_pictures) ? true :false;

					$template->assign_vars(array(
						'S_GALLERY_MANAGEMENT'		=> true,
						'S_GALLERY_MANAGE_DELETE'	=> true,
						'L_GALLERY_TITLE'			=> $user->lang['GALLERY_ALBUM_DELETE_TITLE'],
						'L_GALLERY_EXPLAIN'			=> $user->lang['GALLERY_ALBUM_DELETE_EXPLAIN'],
						'U_ACTION'					=> $this->u_action . "&amp;action=delete&amp;album_id=$album_id",
						'L_ALBUM_DELETE'			=> $user->lang['GALLERY_DELETE'],
						'L_ALBUM_NAME'				=> $user->lang['GALLERY_NAME'],
						'ALBUM_NAME'				=> $album_name,
						'L_ALBUM_DESC'				=> $user->lang['GALLERY_DESCRIPTION'],
						'L_ALBUM_DESC_EXPLAIN'		=> $album_description
						)
					);
					
					if ($has_content)
					{
						$template->assign_vars(array(
							'S_HAS_CONTENT'		=> $has_content,
							'L_ALBUM_CONTENT'	=> $user->lang['GALLERY_CONTENT'],
							'L_ALBUM_DELETE'	=> $user->lang['GALLERY_DELETE']
							)
						);
						
						$sql = 'SELECT album_id, album_name 
								FROM ' . GALLERY_ALBUMS_TABLE . "
								WHERE album_parent_id = 0
									AND album_id <> $album_id
									AND album_user_id = 0";
						$result = $db->sql_query($sql);
						$albums_list = '';
						if ($row = $db->sql_fetchrow($result))
						{
							do
							{
								$albums_list	.= '<option value="' . $row['album_id'] . '">' . $row['album_name'] . '</option>';
							}
							while ($row = $db->sql_fetchrow($result));
						}
						$db->sql_freeresult($result);
						
						$template->assign_vars(array(
							'L_ALBUM_MOVE_CONTENT'			=> $user->lang['GALLERY_MOVE_TO'],
							'ALBUM_MOVE_CONTENT_OPTIONS'	=> $albums_list
							)
						);
					}
				}
				$db->sql_freeresult($result);	
			}
			else
			{
				trigger_error($user->lang['GALLERY_INVALID_ALBUM_ID_MSG'], E_USER_WARNING);
			}
		}
		else
		{
			trigger_error($user->lang['GALLERY_MISSING_ALBUM_ID_MSG'], E_USER_WARNING);
		}
	}
	
	function manage_albums()
	{
		global $db, $template, $user;
		
		$subalbum = isset($_GET['parent_id']) ? true : false;
		
		if ($subalbum)
		{
			$parent_id = (int) request_var('parent_id', 0);
			
			if ($parent_id > 0)
			{
				$sql = 'SELECT album_name
						FROM ' . GALLERY_ALBUMS_TABLE . "
						WHERE album_id = $parent_id";
				$result = $db->sql_query($sql);
				if ($row = $db->sql_fetchrow($result))
				{
					$template->assign_vars(array(
						'S_IS_SUBALBUM'		=> true,
						'PARENT_ALBUM_NAME'	=> $row['album_name']
						)
					);
				}
			}
				
		}
				
		$template->assign_vars(array(
			'S_GALLERY_MANAGEMENT'		=> true,
			'S_GALLERY_MANAGE_ALBUMS'	=> true,
			'L_GALLERY_TITLE'		=> $user->lang['GALLERY_MANAGE_ALBUMS_TITLE'],
			'L_GALLERY_EXPLAIN'		=> $user->lang['GALLERY_MANAGE_ALBUMS_EXPLAIN']
			)
		);
		
		$sql = 'SELECT album_id, album_parent_id, album_name, album_desc
				FROM ' . GALLERY_ALBUMS_TABLE . '
				WHERE album_user_id = 0 
					AND album_parent_id = ' . ($subalbum ? (int) request_var('parent_id', 0) : 0) . '
						ORDER BY album_left_id';
		$result = $db->sql_query($sql);

		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$template->assign_block_vars('albums', array(
					'FOLDER_IMAGE'			=> '<img src="images/icon_gallery.gif" alt="Album" />',
					'U_ALBUM'				=> $this->u_action . '&amp;parent_id=' . $row['album_id'],
					'ALBUM_NAME'			=> $row['album_name'],
					'ALBUM_DESCRIPTION'		=> $row['album_desc'],
					'U_MOVE_UP'				=> $this->u_action . '&amp;action=move_up&amp;album_id=' . $row['album_id'],
					'U_MOVE_DOWN'			=> $this->u_action . '&amp;action=move_down&amp;album_id=' . $row['album_id'],
					'U_EDIT'				=> $this->u_action . '&amp;action=edit&amp;album_id=' . $row['album_id'],
					'U_DELETE'				=> $this->u_action . '&amp;action=delete&amp;album_id=' . $row['album_id']
					)
				);
			}
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);
		
	}

	function create_album()
	{
		global $db, $template, $user;
		
		$create = isset($_POST['create']) ? true : false;
		
		if ($create)
		{
			$parent_id		= (int) request_var('parent', 0);
			$name			= utf8_normalize_nfc(request_var('name', '', true));
			$description	= utf8_normalize_nfc(request_var('description', '', true));
			
			$sql = 'SELECT MAX(album_right_id) AS right_id
					FROM ' . GALLERY_ALBUMS_TABLE;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			
			$left_id	= (int) $row['right_id'] + 1;
			$right_id	= (int) $row['right_id'] + 2;
			
			$sql_array = array (
				'album_parent_id'	=> $parent_id,
				'album_left_id'		=> $left_id,
				'album_right_id'	=> $right_id,
				'album_name'		=> $name,
				'album_desc'		=> $description
			);
			
			$db->sql_query('INSERT INTO  ' . GALLERY_ALBUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array));
			trigger_error($user->lang['GALLERY_ALBUM_CREATED_MSG']);
		}
		else
		{
			$template->assign_vars(array(
				'S_GALLERY_MANAGEMENT'	=> true,
				'S_GALLERY_CREATE_ALBUM'=> true,
				'L_GALLERY_TITLE'		=> $user->lang['GALLERY_ALBUM_CREATE_TITLE'],
				'L_GALLERY_EXPLAIN'		=> $user->lang['GALLERY_ALBUM_CREATE_EXPLAIN'],
				'U_ACTION'				=> $this->u_action,
				'L_ALBUM_SETTINGS'		=> $user->lang['GALLERY_ALBUM_SETTINGS'],
				'L_ALBUM_PARENT'		=> $user->lang['GALLERY_PARENT'],
				'ALBUM_PARENT_OPTIONS'	=> $this->get_parents(),
				'L_ALBUM_NAME'			=> $user->lang['GALLERY_NAME'],
				'L_ALBUM_DESCRIPTION'	=> $user->lang['GALLERY_DESCRIPTION']				
				)
			);
		}
	}

	function manage_cache()
	{
		global $template, $user;
		
		$template->assign_vars(array(
			'S_GALLERY_MANAGEMENT'		=> true,
			'S_GALLERY_MANAGE_CACHE'	=> true,
			'L_GALLERY_TITLE'			=> $user->lang['GALLERY_ALBUM_CACHE_TITLE'],
			'L_GALLERY_EXPLAIN'			=> $user->lang['GALLERY_ALBUM_CACHE_EXPLAIN']
			)
		);
	}

	function general_settings()
	{
		global $db, $template, $user;
		
		$update = isset($_POST['update']) ? true : false;
		
		if ($update)
		{
			$pics_per_page			= (int) request_var('pics_per_page', 5);
			$comments_per_page		= (int) request_var('comments_per_page', 15);
			$comments_to_access		= (int) request_var('comments_to_access', 0);
			$comments_to_post			= (int) request_var('comments_to_post', 0);
			$comments_need_approval		= (int) request_var('comments_need_approval', 0);
			$max_filesize			= (int) request_var('max_filesize', 524288);
			$max_width				= (int) request_var('max_width', 800);
			$max_height				= (int) request_var('max_height', 600);
			$bigger_allowed			= (int) request_var('allow_bigger', 1);
			$jpg_allowed			= (int) request_var('allow_jpeg', 1);
			$gif_allowed			= (int) request_var('allow_gif', 1);
			$png_allowed			= (int) request_var('allow_png', 1);
			$thumb_quality			= (int) request_var('thumbnail_quality', 50);
			$thumb_cache			= (int) request_var('thumbnail_cache', 1);

			$settings = array (
				'pics_per_page'			=> $pics_per_page,
				'comments_per_page'		=> $comments_per_page,
				'comments_to_access'		=> $comments_to_access,
				'comments_to_post'		=> $comments_to_post,
				'comments_need_approval'	=> $comments_need_approval,
				'max_filesize'			=> $max_filesize,
				'max_width'				=> $max_width,
				'max_height'			=> $max_height,
				'bigger_allowed'			=> $bigger_allowed,
				'jpg_allowed'			=> $jpg_allowed,
				'gif_allowed'			=> $gif_allowed,
				'png_allowed'			=> $png_allowed,
				'thumbnail_quality'		=> $thumb_quality,
				'thumbnail_cache'	=> $thumb_cache
			);

			foreach ($settings as $key => $value)
			{
				$sql_ary = array('config_value' => $value);
				$db->sql_query('UPDATE ' . GALLERY_CONFIG_TABLE . ' 
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
								WHERE config_name = '$key'");
			}
			
			trigger_error($user->lang['GALLERY_SETTINGS_UPDATED_MSG']);
		}
		else
		{
			$gallery_config = array();
			$sql = 'SELECT *
					FROM ' . GALLERY_CONFIG_TABLE;
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				do
				{
					$gallery_config[ $row['config_name'] ] = $row['config_value'];
				} 
				while ($row = $db->sql_fetchrow($result));
			}
			$db->sql_freeresult($result);
			
			switch ((int) $gallery_config['thumbnail_quality'])
			{
				case 10:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY10';
				break;

				case 20:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY20';
				break;

				case 30:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY30';
				break;

				case 40:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY40';
				break;

				case 50:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY50';
				break;

				case 60:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY60';
				break;

				case 70:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY70';
				break;

				case 80:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY80';
				break;

				case 90:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY90';
				break;

				case 100:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY100';
				break;
				
				default:
					$s_gallery_thumbnail_quality = 'S_GALLERY_THUMBNAIL_QUALITY50';
				break;
			}
			
			$template->assign_vars(array(
				'S_GALLERY_SETTINGS'					=> true,
				'L_GALLERY_TITLE'						=> $user->lang['GALLERY_SETTINGS_TITLE'],
				'L_GALLERY_EXPLAIN'					=> $user->lang['GALLERY_SETTINGS_EXPLAIN'],
				'L_GALLERY_SETTINGS'					=> $user->lang['GALLERY_GENERAL_SETTINGS'],
				'L_GALLERY_PICS_PER_PAGE'				=> $user->lang['GALLERY_PICS_PER_PAGE'],
				'GALLERY_PICS_PER_PAGE'					=> $gallery_config['pics_per_page'],
				'L_GALLERY_PICS_PER_PAGE_EXPLAIN'			=> $user->lang['GALLERY_PICS_PER_PAGE_EXPLAIN'],
				'L_GALLERY_COMMENTS_PER_PAGE'				=> $user->lang['GALLERY_COMMENTS_PER_PAGE'],
				'GALLERY_COMMENTS_PER_PAGE'				=> $gallery_config['comments_per_page'],
				'L_GALLERY_COMMENTS_PER_PAGE_EXPLAIN'		=> $user->lang['GALLERY_COMMENTS_PER_PAGE_EXPLAIN'],
				'GALLERY_ACCESS_COMMENTS'				=> $gallery_config['comments_to_access'],
				'L_GALLERY_ACCESS_COMMENTS'				=> $user->lang['GALLERY_ACCESS_COMMENTS'],
				'L_GALLERY_ACCESS_COMMENTS_EXPLAIN'			=> $user->lang['GALLERY_ACCESS_COMMENTS_EXPLAIN'],
				'GALLERY_ACCESS_POSTS'					=> $gallery_config['comments_to_post'],
				'L_GALLERY_ACCESS_POSTS'				=> $user->lang['GALLERY_ACCESS_POSTS'],
				'L_GALLERY_ACCESS_POSTS_EXPLAIN'			=> $user->lang['GALLERY_ACCESS_POSTS_EXPLAIN'],
				'S_GALLERY_APPROVAL_NEEDED'				=> ((int) $gallery_config['comments_need_approval'] == 1 ? true : false),
				'L_GALLERY_APPROVAL_NEEDED'				=> $user->lang['GALLERY_APPROVAL_NEEDED'],
				'L_GALLERY_MAX_FILESIZE'				=> $user->lang['GALLERY_MAX_FILESIZE'],
				'GALLERY_MAX_FILESIZE'					=> $gallery_config['max_filesize'],
				'L_GALLERY_MAX_WIDTH'					=> $user->lang['GALLERY_MAX_IMAGE_WIDTH'],
				'GALLERY_MAX_WIDTH'					=> $gallery_config['max_width'],
				'L_GALLERY_MAX_HEIGHT'					=> $user->lang['GALLERY_MAX_IMAGE_HEIGHT'],
				'GALLERY_MAX_HEIGHT'					=> $gallery_config['max_height'],
				'L_GALLERY_ALLOW_BIGGER'				=> $user->lang['GALLERY_ALLOW_BIGGER_IMAGES'],
				'L_GALLERY_ALLOW_BIGGER_EXPLAIN'			=> $user->lang['GALLERY_ALLOW_BIGGER_IMAGES_EXPLAIN'],
				'S_GALLERY_ALLOW_BIGGER'				=> ((int) $gallery_config['bigger_allowed'] == 1 ? true : false),
				'L_GALLERY_ALLOW_JPEG'					=> $user->lang['GALLERY_ALLOW_JPEG'],
				'S_GALLERY_ALLOW_JPEG'					=> ((int) $gallery_config['jpg_allowed'] == 1 ? true : false),
				'L_GALLERY_ALLOW_GIF'					=> $user->lang['GALLERY_ALLOW_GIF'],
				'S_GALLERY_ALLOW_GIF'					=> ((int) $gallery_config['gif_allowed'] == 1 ? true : false),
				'L_GALLERY_ALLOW_PNG'					=> $user->lang['GALLERY_ALLOW_PNG'],
				'S_GALLERY_ALLOW_PNG'					=> ((int) $gallery_config['png_allowed'] == 1 ? true : false),
				'L_GALLERY_THUMBNAIL_QUALITY'				=> $user->lang['GALLERY_THUMBNAIL_QUALITY'],
				'L_GALLERY_THUMBNAIL_CACHE'				=> $user->lang['GALLERY_CACHE_THUMBNAILS'],
				'S_GALLERY_THUMBNAIL_CACHE'				=> ((int) $gallery_config['thumbnail_cache'] == 1 ? true : false)			
				)
			);
						$s_gallery_thumbnail_quality		= true;
			}
	}

	function user_settings()
	{
		global $db, $template, $user;
		
		$update = isset($_POST['update']) ? true : false;
		
		if ($update)
		{

			$users_can_upload			= (int) request_var('users_can_upload', 1);
			$users_can_delete_images	= (int) request_var('users_can_delete_images', 0);
			$users_can_comment		= (int) request_var('users_can_comment', 1);
			$users_can_edit_comments	= (int) request_var('users_can_edit_comments', 0);
			$users_can_delete_comments	= (int) request_var('users_can_delete_comments', 0);
			$users_can_move_pics		= (int) request_var('users_can_move_pics', 0);
			$users_can_create_subalbums	= (int) request_var('users_can_create_subalbums', 0);
			$users_can_delete_subalbums	= (int) request_var('users_can_delete_subalbums', 0);
			$max_subalbums			= (int) request_var('max_subalbums', 1);
			$users_can_set_approval		= (int) request_var('users_can_set_approval', 0);

			$settings = array (

				'users_can_upload'		=> $users_can_upload,
				'users_can_delete_images'	=> $users_can_delete_images,
				'users_can_comment'		=> $users_can_comment,
				'users_can_edit_comments'	=> $users_can_edit_comments,
				'users_can_delete_comments'	=> $users_can_delete_comments,
				'users_can_move_pics'		=> $users_can_move_pics,
				'users_can_create_subalbums'	=> $users_can_create_subalbums,
				'users_can_delete_subalbums'	=> $users_can_delete_subalbums,
				'max_subalbums'			=> $max_subalbums,
				'users_can_set_approval'	=> $users_can_set_approval,

			);

			foreach ($settings as $key => $value)
			{
				$sql_ary = array('config_value' => $value);
				$db->sql_query('UPDATE ' . GALLERY_CONFIG_TABLE . ' 
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
								WHERE config_name = '$key'");
			}
			
			trigger_error($user->lang['GALLERY_SETTINGS_UPDATED_MSG']);
		}
		else
		{
			$gallery_config = array();
			$sql = 'SELECT *
					FROM ' . GALLERY_CONFIG_TABLE;
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				do
				{
					$gallery_config[ $row['config_name'] ] = $row['config_value'];
				} 
				while ($row = $db->sql_fetchrow($result));
			}
			$db->sql_freeresult($result);
			
			$template->assign_vars(array(
				'S_USER_SETTINGS'						=> true,
				'L_GALLERY_TITLE'						=> $user->lang['GALLERY_USER_SETTINGS_TITLE'],
				'L_GALLERY_EXPLAIN'					=> $user->lang['GALLERY_USER_SETTINGS_EXPLAIN'],
				'L_GALLERY_SETTINGS'					=> $user->lang['GALLERY_USER_SETTINGS'],

				'S_GALLERY_USER_UPLOAD'					=> ((int) $gallery_config['users_can_upload'] == 1 ? true : false),
				'L_GALLERY_USER_UPLOAD'					=> $user->lang['GALLERY_USER_UPLOAD'],
				'L_GALLERY_USER_UPLOAD_EXPLAIN'			=> $user->lang['GALLERY_USER_UPLOAD_EXPLAIN'],
				'S_GALLERY_USER_DELETE_IMG'				=> ((int) $gallery_config['users_can_delete_images'] == 1 ? true : false),
				'L_GALLERY_USER_DELETE_IMG'				=> $user->lang['GALLERY_USER_DELETE_IMG'],
				'L_GALLERY_USER_DELETE_IMG_EXPLAIN'			=> $user->lang['GALLERY_USER_DELETE_IMG_EXPLAIN'],
				'S_GALLERY_USER_POSTS'					=> ((int) $gallery_config['users_can_comment'] == 1 ? true : false),
				'L_GALLERY_USER_POSTS'					=> $user->lang['GALLERY_USER_POSTS'],
				'L_GALLERY_USER_POSTS_EXPLAIN'			=> $user->lang['GALLERY_USER_POSTS_EXPLAIN'],
				'S_GALLERY_USER_EDIT_POSTS'				=> ((int) $gallery_config['users_can_edit_comments'] == 1 ? true : false),
				'L_GALLERY_USER_EDIT_POSTS'				=> $user->lang['GALLERY_USER_EDIT_POSTS'],
				'L_GALLERY_USER_EDIT_POSTS_EXPLAIN'			=> $user->lang['GALLERY_USER_EDIT_POSTS_EXPLAIN'],
				'S_GALLERY_USER_DELETE_POSTS'				=> ((int) $gallery_config['users_can_delete_comments'] == 1 ? true : false),
				'L_GALLERY_USER_DELETE_POSTS'				=> $user->lang['GALLERY_USER_DELETE_POSTS'],
				'L_GALLERY_USER_DELETE_POSTS_EXPLAIN'		=> $user->lang['GALLERY_USER_DELETE_POSTS_EXPLAIN'],
				'S_GALLERY_USER_MOVE_PICS'				=> ((int) $gallery_config['users_can_move_pics'] == 1 ? true : false),
				'L_GALLERY_USER_MOVE_PICS'				=> $user->lang['GALLERY_USER_MOVE_PICS'],
				'L_GALLERY_USER_MOVE_PICS_EXPLAIN'			=> $user->lang['GALLERY_USER_MOVE_PICS_EXPLAIN'],
				'S_GALLERY_USER_CREATE_SUB'				=> ((int) $gallery_config['users_can_create_subalbums'] == 1 ? true : false),
				'L_GALLERY_USER_CREATE_SUB'				=> $user->lang['GALLERY_USER_CREATE_SUB'],
				'L_GALLERY_USER_CREATE_SUB_EXPLAIN'			=> $user->lang['GALLERY_USER_CREATE_SUB_EXPLAIN'],
				'S_GALLERY_USER_DELETE_SUB'				=> ((int) $gallery_config['users_can_delete_subalbums'] == 1 ? true : false),
				'L_GALLERY_USER_DELETE_SUB'				=> $user->lang['GALLERY_USER_DELETE_SUB'],
				'L_GALLERY_USER_DELETE_SUB_EXPLAIN'			=> $user->lang['GALLERY_USER_DELETE_SUB_EXPLAIN'],
				'GALLERY_MAX_SUB'						=> $gallery_config['max_subalbums'],
				'L_GALLERY_MAX_SUB'					=> $user->lang['GALLERY_MAX_SUB'],
				'L_GALLERY_MAX_SUB_EXPLAIN'				=> $user->lang['GALLERY_MAX_SUB_EXPLAIN'],
				'S_GALLERY_USER_SET_APPROVAL'				=> ((int) $gallery_config['users_can_set_approval'] == 1 ? true : false),
				'L_GALLERY_USER_SET_APPROVAL'				=> $user->lang['GALLERY_SET_APPROVAL'],
				'L_GALLERY_USER_SET_APPROVAL_EXPLAIN'		=> $user->lang['GALLERY_USER_SET_APPROVAL_EXPLAIN'],
			
				)
			);

			}
	}

	function guest_settings()
	{
		global $db, $template, $user;
		
		$update = isset($_POST['update']) ? true : false;
		
		if ($update)
		{

			$guests_can_access		= (int) request_var('guests_can_access', 1);
			$guests_can_comment		= (int) request_var('guests_can_comment', 0);
			$guests_need_approval		= (int) request_var('guests_need_approval', 0);
			$guests_can_upload		= (int) request_var('guests_can_upload', 0);

			$settings = array (

				'guests_can_access'		=> $guests_can_access,
				'guests_can_comment'		=> $guests_can_comment,
				'guests_need_approval'		=> $guests_need_approval,
				'guests_can_upload'		=> $guests_can_upload,

			);

			foreach ($settings as $key => $value)
			{
				$sql_ary = array('config_value' => $value);
				$db->sql_query('UPDATE ' . GALLERY_CONFIG_TABLE . ' 
								SET ' . $db->sql_build_array('UPDATE', $sql_ary) . "
								WHERE config_name = '$key'");
			}
			
			trigger_error($user->lang['GALLERY_SETTINGS_UPDATED_MSG']);
		}
		else
		{
			$gallery_config = array();
			$sql = 'SELECT *
					FROM ' . GALLERY_CONFIG_TABLE;
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				do
				{
					$gallery_config[ $row['config_name'] ] = $row['config_value'];
				} 
				while ($row = $db->sql_fetchrow($result));
			}
			$db->sql_freeresult($result);
			
			$template->assign_vars(array(
				'S_GUEST_SETTINGS'					=> true,
				'L_GALLERY_TITLE'						=> $user->lang['GALLERY_GUEST_SETTINGS_TITLE'],
				'L_GALLERY_EXPLAIN'					=> $user->lang['GALLERY_GUEST_SETTINGS_EXPLAIN'],
				'L_GALLERY_SETTINGS'					=> $user->lang['GALLERY_GUEST_SETTINGS'],

				'S_GALLERY_GUEST_ACCESS'				=> ((int) $gallery_config['guests_can_access'] == 1 ? true : false),
				'L_GALLERY_GUEST_ACCESS'				=> $user->lang['GALLERY_GUEST_ACCESS'],
				'L_GALLERY_GUEST_ACCESS_EXPLAIN'			=> $user->lang['GALLERY_GUEST_ACCESS_EXPLAIN'],
				'S_GALLERY_GUEST_POSTS'					=> ((int) $gallery_config['guests_can_comment'] == 1 ? true : false),
				'L_GALLERY_GUEST_POSTS'					=> $user->lang['GALLERY_GUEST_POSTS'],
				'L_GALLERY_GUEST_POSTS_EXPLAIN'			=> $user->lang['GALLERY_GUEST_POSTS_EXPLAIN'],
				'S_GALLERY_GUEST_APPROVAL'				=> ((int) $gallery_config['guests_need_approval'] == 1 ? true : false),
				'L_GALLERY_GUEST_APPROVAL'				=> $user->lang['GALLERY_GUEST_APPROVAL'],
				'L_GALLERY_GUEST_APPROVAL_EXPLAIN'			=> $user->lang['GALLERY_GUEST_APPROVAL_EXPLAIN'],
				'S_GALLERY_GUEST_UPLOAD'				=> ((int) $gallery_config['guests_can_upload'] == 1 ? true : false),
				'L_GALLERY_GUEST_UPLOAD'				=> $user->lang['GALLERY_GUEST_UPLOAD'],
				'L_GALLERY_GUEST_UPLOAD_EXPLAIN'			=> $user->lang['GALLERY_GUEST_UPLOAD_EXPLAIN'],
			
				)
			);

			}
	}

	function get_parents($album_id = 0, $album_parent_id = 0)
	{
		global $db;
		
		$sql = 'SELECT album_id, album_name
				FROM ' . GALLERY_ALBUMS_TABLE . '
				WHERE album_parent_id = 0 
					AND album_user_id = 0';
		if ($album_id > 0)
		{
			$sql .= " AND album_id <> {$album_id}";
		}
	
		$result = $db->sql_query($sql);
		$options = '<option value="0"' .  ($album_parent_id == 0 ? 'selected="selected">' : '') . 'No parent</option>
					<option value="-1" disabled="disabled">&nbsp;</option>';
		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$this_album_id 	= (int) $row['album_id'];
				$this_album_name = $row['album_name'];
				$options	.= "<option value=\"{$this_album_id}\"" . ($album_parent_id == $this_album_id ? 'selected="selected">' : '') . ">{$this_album_name}</option>";
			}
			while ($row = $db->sql_fetchrow($result));
			$db->sql_freeresult($result);
		}
		return $options;
	}
}
			
?>