<?php
/**
*
* @package TS Gallery
* @version $Id: gallery.php,v 0.1.1 2007/11/30 14:15:10 uber geek Exp $
* @copyright (c) 2007 threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class Gallery
{
	var $config;
	
	function load_config()
	{
		global $db;
		
		$sql = 'SELECT *
				FROM ' . GALLERY_CONFIG_TABLE;

		$result = $db->sql_query($sql);
		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$this->config[ $row['config_name'] ] = (int) $row['config_value'];
			} 
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);
	}
	
	function get_config($name)
	{
		return $this->config[$name];
	}
	
	function generate_menu($page = GALLERY_PAGE_BROWSE)
	{
		global $template, $phpEx, $user, $db;
		
		$template->assign_block_vars('tabs', array(
			'S_SELECTED'	=> ($page == GALLERY_PAGE_BROWSE ? true : false),

// 'U_TITLE' => BUG (0001) Fixed by Uber Geek - (http://threesixes.co.uk)
			'U_TITLE'		=> append_sid("menu.{$phpEx}"),
// End fix
			'L_TITLE'		=> $user->lang['GALLERY_MENU_BROWSE']
			)
		);
		
		if ($user->data['is_registered'])
		{
			$sql = 'SELECT album_id  
					FROM ' . GALLERY_ALBUMS_TABLE . ' 
					WHERE album_user_id = ' . $user->data['user_id'];
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('tabs', array(
					'S_SELECTED'	=> ($page == GALLERY_PAGE_MYALBUM ? true : false),
					'U_TITLE'		=> append_sid("menu.{$phpEx}", '?gallery=members&amp;album_id=' . $row['album_id']),
					'L_TITLE'		=> $user->lang['GALLERY_MENU_MYALBUM']
					)
				);
			}
			$db->sql_freeresult($result);
		}
			
		$template->assign_block_vars('tabs', array(
			'S_SELECTED'	=> ($page == GALLERY_PAGE_HOT ? true : false),
			'U_TITLE'		=> append_sid("hot.{$phpEx}?start=0"),
			'L_TITLE'		=> $user->lang['GALLERY_MENU_HOT']
			)
		);
		$template->assign_block_vars('tabs', array(
			'S_SELECTED'	=> ($page == GALLERY_PAGE_RECENT ? true : false),
			'U_TITLE'		=> append_sid("recent.{$phpEx}?start=0"),
			'L_TITLE'		=> $user->lang['GALLERY_MENU_RECENT']
			)
		);
		$template->assign_block_vars('tabs', array(
			'S_SELECTED'	=> ($page == GALLERY_PAGE_VIEWS ? true : false),
			'U_TITLE'		=> append_sid("views.{$phpEx}?start=0"),
			'L_TITLE'		=> $user->lang['GALLERY_MENU_VIEWS']
			)
		);
		$template->assign_block_vars('tabs', array(
			'S_SELECTED'	=> ($page == GALLERY_PAGE_UPLOAD ? true : false),
			'U_TITLE'		=> append_sid("upload.{$phpEx}"),
			'L_TITLE'		=> $user->lang['GALLERY_MENU_UPLOAD']
			)
		);		
	}
	
	function get_albums()
	{
		global $db, $user;
		
		$sql = 'SELECT album_id, album_name  
				FROM ' . GALLERY_ALBUMS_TABLE . '
				WHERE album_parent_id = 0
					AND album_user_id = 0';
		
		$result = $db->sql_query($sql);
		
		$options = '<option value="0">' . $user->lang['GALLERY_PERSONAL_ALBUM'] . '</option>
					<option value="-1" disabled="disabled">------------------------------</option>';
		
		$albums = array();
		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$albums[]	= array(
								'album_id'		=> $row['album_id'],
								'album_name'	=> $row['album_name']
							);
			}
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);
		
		foreach ($albums as $item)
		{
			$options .= '<option value="' . $item['album_id'] . '">|--' . $item['album_name'] . '</option>';
			
			$sql = 'SELECT album_id, album_name  
					FROM ' . GALLERY_ALBUMS_TABLE . ' 
					WHERE album_parent_id = ' . $item['album_id'] . '
						AND album_user_id = 0';
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
			{
				do
				{
					$options .= '<option value="' . $row['album_id'] . '">|&nbsp;&nbsp;&nbsp;|--' . $row['album_name'] . '</option>';
				}
				while ($row = $db->sql_fetchrow($result));
			}
		}
		$db->sql_freeresult($result);
		
		return $options;
	}	
	
	function handle_upload($form_name = 'fileupload')
	{
		global $phpbb_root_path, $phpEx, $user;

		$filedata = array(
			'error'	=> array()
		);
	
		$upload = new fileupload();

		$filedata['post_attach'] = ($upload->is_valid($form_name)) ? true : false;

		if (!$filedata['post_attach'])
		{
			$filedata['error'][] = $user->lang['NO_UPLOAD_FORM_FOUND'];
			return $filedata;
		}
		
			
		$extensions = array();

		if ( (int) $this->config['jpg_allowed'] == 1 )
		{
			$extensions[] = 'jpg';
			$extensions[] = 'jpeg';
		}
		
		if ( (int) $this->config['gif_allowed'] == 1 )
		{
			$extensions[] = 'gif';
		}
		
		if ( (int) $this->config['gif_allowed'] == 1 )
		{
			$extensions[] = 'png';
		}
		
		$upload->set_allowed_extensions($extensions);
		$file = $upload->form_upload($form_name);

		if ($file->init_error)
		{
			$filedata['post_attach'] = false;
			return $filedata;
		}

		if (!$file->is_image())
		{
			$file->remove();
			$filedata['error'][] = $user->lang['ATTACHED_IMAGE_NOT_IMAGE'];
			return $filedata;
		}
		
		if((int) $this->config['bigger_allowed'] == 0)
		{
			$file->upload->set_allowed_dimensions(0, 0, (int) $this->config['max_width'], (int) $this->config['max_height']);
		}
		
		$file->clean_filename('unique');
		$file->move_file('gallery/upload/pics', false, false);
		
		if (sizeof($file->error))
		{
			$file->remove();
			$filedata['error'][] = $file->error;
			$filedata['post_attach'] = false;
			return $filedata;
		}

		if((int) $this->config['bigger_allowed'] == 1)
		{
			if ($file->get('height') > (int) $this->config['max_width'] || $file->get('width') > (int) $this->config['max_height'])
			{
				$destination = $source = $file->get('destination_file');
				if (!$this->create_thumbnail($source, $destination, $file->get('mimetype')))
				{
					$file->remove();
					$filedata['error'][] = $user->lang['GALLERY_ERROR_RESIZEING_PIC'];
					$filedata['post_attach'] = false;
					return $filedata;
				}
			}
		}

		$filedata['filesize'] = $file->get('filesize');
		$filedata['physical_filename'] = $file->get('realname');
		$filedata['real_filename'] = $file->get('uploadname');
		$filedata['filetime'] = time();
		$filedata['mimetype'] = $file->get('mimetype');

		// Check free disk space
		if ($free_space = @disk_free_space($phpbb_root_path . $config['upload_path']))
		{
			if ($free_space <= $file->get('filesize'))
			{
				$filedata['error'][] = $user->lang['ATTACH_QUOTA_REACHED'];
				$filedata['post_attach'] = false;
				$file->remove();
				return $filedata;
			}
		}
		return $filedata;
	}
	
	function create_thumbnail($source, $destination, $mimetype, $size = 'large') 
	{
		global $config;

		$min_filesize 	= (int) $config['img_min_thumb_filesize'];
		$img_filesize 	= (file_exists($source)) ? @filesize($source) : false;
		
		if (!$img_filesize || $img_filesize <= $min_filesize)
		{
			return false;
		}

		$dimension = @getimagesize($source);

		if ($dimension === false)
		{
			return false;
		}
		
		list($width, $height) = $dimension;
		
		if ($size == 'small')
		{
			$max_width	= 128;
			$max_height	= 128;
		}
		else if ($size == 'med')
		{
			$max_width	= 640;
			$max_height	= 480;
		}
		else
		{
			$max_width	= (int) $this->config['max_width'];
			$max_height	= (int) $this->config['max_height'];
		}

		if (empty($width) || empty($height))
		{
			return false;
		}
		
		if ($width > $height)
		{
			$new_width	= round($width * ($max_width / $width));
			$new_height	= round($height * ($max_width / $width));
		}
		else
		{
			$new_width	= round($width * ($max_width / $height));
			$new_height	= round($height * ($max_width / $height));
		}
		

		// Do not create a thumbnail if the resulting width/height is bigger than the original one
		if ($new_width > $width && $new_height > $height)
		{
			$new_width	= $width;
			$new_height	= $height;			
		}
		
		switch ($mimetype) 
		{
			case 'image/gif':
				$image = @imagecreatefromgif($source);
			break;

			case 'image/jpg':
			case 'image/jpeg':
				$image = @imagecreatefromjpeg($source);
			break;

			case 'image/png':
				$image = @imagecreatefrompng($source);
			break;
		}

		if (function_exists('imagecreatetruecolor'))
		{
			$new_image = imagecreatetruecolor($new_width, $new_height);

			if ($new_image === false)
			{
				return false;
			}

			imagecopyresampled($new_image, $image, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
		}
		else
		{
			$new_image = imagecreate($new_width, $new_height);

			if ($new_image === false)
			{
				return false;
			}

			imagecopyresized($new_image, $image, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
		}

		// If we are in safe mode create the destination file prior to using the gd functions to circumvent a PHP bug
		if (@ini_get('safe_mode') || @strtolower(ini_get('safe_mode')) == 'on')
		{
			@touch($destination);
		}

		switch ($mimetype) 
		{
			case 'image/gif':
				imagegif($new_image, $destination);
			break;

			case 'image/jpg':
			case 'image/jpeg':
				$image_quality = ($size == 'small' || $size = 'med') ? (int) $this->config['thumbnail_quality'] : 100;
				imagejpeg($new_image, $destination, $image_quality);
			break;

			case 'image/png':
				imagepng($new_image, $destination);
			break;
		}

		imagedestroy($new_image);

		
		if (!file_exists($destination))
		{
			return false;
		}

		@chmod($destination, 0666);
		
		return true;
	}
	
	function redirect($meta_url, $message, $delay)
	{
		meta_refresh($delay, $meta_url);
		trigger_error($message);
	}

		function get_num_pics($where, $equals, $this_user, $skel_key)
		{
		global $db;
		$sql = 'SELECT COUNT(pic_id) AS num_pics
			FROM ' . GALLERY_PICS_TABLE . "
			WHERE {$where} = " . $equals;
		$result = $db->sql_query($sql);
		$total_pics = (int) $db->sql_fetchfield('num_pics');
		$db->sql_freeresult($result);
	$admin = $skel_key;
	if (!$admin)
		{
			$sql = 'SELECT a.*, z.*
				FROM ' . GALLERY_ALBUMS_TABLE . ' AS a
				LEFT JOIN ' . ZEBRA_TABLE . ' AS z ON a.album_user_id = z.user_id && z.zebra_id = ' . $this_user . "
				WHERE a.album_show_gallery = 1
				GROUP BY a.album_user_id ";
			$result = $db->sql_query($sql);
			if ($row = $db->sql_fetchrow($result))
				{
					$locked = 0;
					$key = 0;
					do
						{	
							if ($row['album_user_id'] !== $this_user)
								{	
									$locked = $locked + 1;
									$key = $key + (int) $row['friend'];
								}	
						}
					while ($row = $db->sql_fetchrow($result));
				}

				$db->sql_freeresult($result);

				$locked = $locked - $key;
				$total_pics = $total_pics - $locked;
			}
		return $total_pics;
		}	

		function get_prev_pic($pic_id, $pic_album_id)
		{
		global $db;
		$sql = 'SELECT pic_id
			FROM ' . GALLERY_PICS_TABLE . "
			WHERE pic_id < " . $pic_id . ' && pic_album_id = ' . $pic_album_id;
		$result = $db->sql_query($sql);
		$prev_pic = (int) $db->sql_fetchfield('pic_id');
		$db->sql_freeresult($result);

		return $prev_pic;
		}	

		function get_next_pic($pic_id, $pic_album_id)
		{
		global $db;
		$sql = 'SELECT pic_id
			FROM ' . GALLERY_PICS_TABLE . "
			WHERE pic_id > " . $pic_id . ' && pic_album_id = ' . $pic_album_id;
		$result = $db->sql_query($sql);
		$next_pic = (int) $db->sql_fetchfield('pic_id');
		$db->sql_freeresult($result);

		return $next_pic;
		}	


}
?>