<?php
/**
*
* @package TS Gallery
* @version $Id: gallery_ucp_prefs.php,v 0.1.1 2007/11/30 14:15:10 uber geek Exp $
* @copyright (c) 2007 threesixes.co.uk
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_gallery_prefs
* Changing gallery preferences
* @package TS Gallery
*/

class ucp_gallery_prefs
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;

		$sql = 'SELECT *
			FROM ' . GALLERY_ALBUMS_TABLE . "
			WHERE album_user_id = " . $user->data['user_id']; 
		$result = $db->sql_query($sql);
		$album_data = $db->sql_fetchrow($result);

		$submit = (isset($_POST['submit'])) ? true : false;
		$error = $data = array();
		$s_hidden_fields = '';

		switch ($mode)
		{
			case 'personal':
				$user->add_lang('mods/gallery');
				add_form_key('ucp_gallery_prefs_personal');
				$data = array(
					'show_gallery'		=> request_var('show_gallery', $album_data['album_show_gallery']),
					'allow_comments'		=> request_var('allow_comments', $album_data['album_allow_comments']),
					'comment_approval'	=> request_var('comment_approval', $album_data['album_comment_approval']),
				);

				if ($submit)
				{
					$data['style'] = ($config['override_user_style']) ? $config['default_style'] : $data['style'];


					if (!check_form_key('gallery_ucp_prefs_personal'))
					{
						$error[] = 'FORM_INVALID';
					}

						$sql_ary = array(
							'album_show_gallery'		=> $data['show_gallery'],
							'album_allow_comments'		=> $data['allow_comments'],
							'album_comment_approval'	=> $data['comment_approval'],
						);

						$sql = 'UPDATE ' . GALLERY_ALBUMS_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
							WHERE album_user_id = ' . $user->data['user_id'];
						$db->sql_query($sql);

						meta_refresh(3, $this->u_action);
						$message = $user->lang['GALLERY_PREFERENCES_UPDATED'] . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);

				}

				$template->assign_vars(array(
					'ERROR'				=> (sizeof($error)) ? implode('<br />', $error) : '',

					'L_SHOW_GALLERY'				=> $user->lang['UCP_SHOW_GALLERY'],
					'L_ALLOW_GALLERY_COMMENTS'		=> $user->lang['UCP_ALLOW_GALLERY_COMMENTS'],
					'L_GALLERY_COMMENT_APPROVAL'		=> $user->lang['UCP_GALLERY_COMMENT_APPROVAL'],
					'L_NO_OPTIONS'				=> $user->lang['UCP_NO_OPTIONS'],

					'S_SHOW_GALLERY'				=> $data['show_gallery'],
					'S_ALLOW_COMMENTS'			=> $data['allow_comments'],
					'S_COMMENT_APPROVAL'			=> $data['comment_approval'],

					'T_CONTROL_SHOW'				=> true,
					'T_CONTROL_COMMENTS'			=> true,
					'T_CONTROL_APPROVAL'			=> false, // NOT AVAILABLE IN RELEASE
					)
				);

			break;

			}

		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang['UCP_GALLERY_PREFS_' . strtoupper($mode)],

			'S_GALLERY_HIDDEN_FIELDS'	=> $s_hidden_fields,
			'S_GALLERY_UCP_ACTION'		=> $this->u_action)
		);

		$this->tpl_name = 'gallery/ucp_gallery_prefs_' . $mode;
		$this->page_title = 'UCP_GALLERY_PREFS_' . strtoupper($mode);
	}
}

?>